to_move = input()
checks = []
damka = None
for i in range(8):
    for j, val in enumerate(input().split()):
        if (val == '_'):
            continue
        if (val.isupper() and val.lower() == to_move):
            damka = (j, i)
        else:
            checks.append((j, i))

def adjust(num, value):
    if (num > 0):
        return num + value
    return num - value

def inBounds(pos):
    return pos[0] >= 0 and pos[0] < 8 and pos[1] >= 0 and pos[1] < 8

def isOnTheSameLine(pos1, pos2):
    if ((pos1[0] - pos2[0]) == (pos1[1] - pos2[1])):
        return True
    if ((pos1[0] - pos2[0]) == (pos2[1] - pos1[1])):
        return True
    return False

def check_can_beat(damka, check1, check2):
    if (not isOnTheSameLine(damka, check1)):
        return (False, None)
    direction = (-1 if damka[0] > check1[0] else 1, -1 if damka[1] > check1[1] else 1)
    startPoint = (check1[0] + direction[0], check1[1] + direction[1])
    damka = startPoint
    while True:
        if (not inBounds(damka)):
            return (False, None)
        if (isOnTheSameLine(damka, check2)):
            break
        damka = (damka[0] + direction[0], damka[1] + direction[1])
    positions = []
    positions.append(damka)
    direction = (-1 if damka[0] > check2[0] else 1, -1 if damka[1] > check2[1] else 1)
    endPoint = (check2[0] + direction[0], check2[1] + direction[1])
    if (not inBounds(endPoint)):
        return (False, None)
    positions.append(endPoint)
    return (True, positions)

res1 = check_can_beat(damka, checks[0], checks[1])
res2 = check_can_beat(damka, checks[1], checks[0])
if (res1[0]):
    for pos in res1[1]:
        print(f"{pos[1] + 1} {pos[0] + 1}")
if (res2[0]):
    for pos in res2[1]:
        print(f"{pos[1] + 1} {pos[0] + 1}")