#include <bits/stdc++.h>
using namespace std;
using ll = long long;

const int N0 = 4;
string good_str = "", bad_str = "";
vector<int> answer;

void finding (vector<string> arr, int cur, set<int> curr_cubes, vector<int> road) {
    if (curr_cubes.size() == 0) {
        answer = road;
        return;
    }
    int level = -1;
    for (int j = N0 - 1; j >= 0; j--) {
        if (arr[N0 * cur + j] != good_str) {
            level = j;
            break;
        }
    }
    vector<string> false_str, need_str;
    for (int j = level; j >= 0; j--) {
        false_str.push_back(arr[N0 * cur + j]);
    }
    reverse(false_str.begin(), false_str.end());
    vector<int> cubes;
    for (auto c : curr_cubes) {
        cubes.push_back(c);
    }
    int h = 0;
    while (h < cubes.size()) {
        int elem = cubes[h];
        int cnt = 0, height = N0 - 1;
        while (cnt < level + 1 && height >= 0) {
            if (arr[N0 * elem + height] != bad_str) {
                need_str.push_back(arr[N0 * elem + height]);
                cnt++;
            }
            height--;
        }
        bool flag = true;
        for (int i = 0; i < min(false_str.size(), need_str.size()); i++) {
            for (int j = 0; j < N0; j++) {
                if (false_str[i][j] == need_str[i][j]) {
                    flag = false;
                    break;
                }
            }
            if (!flag) break;
        }
        if (flag) {
            cnt = 0; height = N0 - 1;
            vector<string> arr_copy = arr;
            while (cnt < level + 1 && height >= 0) {
               if (arr_copy[N0 * elem + height] != bad_str) {
                    cnt++;
                }
                arr_copy[N0 * elem + height] = good_str;
                height--;
            }
            curr_cubes.erase(elem);
            road.push_back(elem);
            finding(arr_copy, elem, curr_cubes, road);
            curr_cubes.insert(elem);
            road.pop_back();
        }
        h++;
    }
}

void solve() {
    int N; cin >> N;
    vector<string> arr(N0*N);
    for (int i = 0; i < arr.size(); i++) {
        for (int j = 0; j < N0; j++) {
            char c; cin >> c;
            arr[i] += c;
        }
    }
    int s, f;
    for (int i = 0; i < N0; i++) {
        good_str += '1';
        bad_str += '0';
    }
    for (int i = 0; i < N; i++) {
        if (arr[N0 * i] == good_str) {
            f = i;
            break;
        }
    }
    for (int i = 0; i < N; i++) {
        if (arr[N0 * (i + 1) - 1] == good_str) {
            s = i;
            break;
        }
    }
    if (s == f) {
        cout << s + 1;
        return;
    }
    set<int> curr_cubes;
    for (int i = 0; i < N; i++) {
        curr_cubes.insert(i);
    }
    curr_cubes.erase(s);
    curr_cubes.erase(f);
    if (curr_cubes.size() == 0) {
        cout << s + 1 << " " << f + 1;
        return;
    }
    if (curr_cubes.size() == 1) {
        cout << s + 1 << " " << *curr_cubes.begin() + 1 << " " << f + 1;
        return;
    }
    finding(arr, s, curr_cubes, vector<int>());
    cout << s + 1 << " ";
    for (auto c : answer) {
        cout << c + 1 << " ";
    }
    cout << f + 1;
}

int main() {
    //ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
    int t = 1;
    while (t--) {
        solve();
    }
    return 0;
}
