import itertools

blocks_count = int(input())
blocks = []
for i in range(blocks_count):
    block = []
    for _ in range(3):
        block.append(list(map(int, input().split())))
    blocks.append(block)


if blocks_count == 1:
    print(1)
    exit(0)


def overlap(block1, block2, t):
    block = []
    if t == 0:
        for i in block1:
            block.append(i)
        for i in block2:
            block.append(i)
        return block
    if t == 1:
        block.append(block1[0])
        block.append(block1[1])
        t = [block1[2][0] or block2[0][0],
             block1[2][1] or block2[0][1],
             block1[2][2] or block2[0][2]]
        block.append(t)
        block.append(block2[1])
        block.append(block2[2])
        return block
    if t == 2:
        block.append(block1[0])
        block.append([
             block1[1][0] or block2[0][0],
             block1[1][1] or block2[0][1],
             block1[1][2] or block2[0][2]
        ])
        block.append([
            block1[2][0] or block2[1][0],
            block1[2][1] or block2[1][1],
            block1[2][2] or block2[1][2]
        ])
        block.append(block2[2])
        return block
    if t == 3:
        block.append([
             block1[0][0] or block2[0][0],
             block1[0][1] or block2[0][1],
             block1[0][2] or block2[0][2]
        ])
        block.append([
             block1[1][0] or block2[1][0],
             block1[1][1] or block2[1][1],
             block1[1][2] or block2[1][2]
        ])
        block.append([
             block1[2][0] or block2[2][0],
             block1[2][1] or block2[2][1],
             block1[2][2] or block2[2][2]
        ])
        return block


def count_ones(blocks, t):
    res = 0
    for i in blocks:
        for j in i:
            res += j.count(1)
    return res


def count_zeros(blocks, t):
    if t == 0:
        res = 0
        for i in blocks:
            for j in i:
                res += j.count(0)
        return res
    if t == 1:
        block = blocks[0]
        res = 0
        res += block[2].count(0)
        return res
    if t == 2:
        block = blocks[0]
        res = 0
        res += block[1].count(0)
        res += block[2].count(0)
        return res
    if t == 3:
        block = blocks[0]
        res = 0
        res += block[0].count(0)
        res += block[1].count(0)
        res += block[2].count(0)
        return res


def check(blocks):
    for i in range(len(blocks)-1):
        b1 = blocks[i]
        b2 = blocks[i + 1]
        ones = count_ones([overlap(b1, b2, 0)], 0)
        zeros = count_zeros([overlap(b1, b2, 0)], 0)
        if zeros == 0:
            continue

        if count_ones([overlap(b1, b2, 1)], 1) != ones:
            return False
        zeros = count_zeros([overlap(b1, b2, 1)], 1)
        if zeros == 0:
            continue

        if count_ones([overlap(b1, b2, 2)], 2) != ones:
            return False
        zeros = count_zeros([overlap(b1, b2, 2)], 2)
        if zeros == 0:
            continue

        if count_ones([overlap(b1, b2, 3)], 3) != ones:
            return False
    return True


for i in itertools.permutations(blocks, blocks_count):
    if check(i):
        res = []
        for j in i:
            res.append(blocks.index(j))
        res = res[::-1]
        for num in res:
            print(num+1, end=' ')
