#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
using ll = long long;

vector<pair<int, int>> vec;
char mas[10][10];
int dxx[] = { 1, -1, 1, -1 };
int dyy[] = { 1, -1, -1, 1 };

void dfs(int typ, int x, int y, int dist = 1) {
	if (x > 8 || x < 1 || y > 8 || y < 1) return;
	if (mas[x][y] != '_') {
		vec.push_back({ dist, typ });
		return;
	}
	dfs(typ, x + dxx[typ], y + dyy[typ], dist + 1);
}

signed main() {
	char type;
	cin >> type;
	type = toupper(type);
	int x = 0, y = 0;
	vector<pair<int, int>> coord;
	for (int i = 1; i <= 8; ++i) {
		for (int j = 1; j <= 8; ++j) {
			cin >> mas[i][j];
			if (mas[i][j] == type) {
				x = i;
				y = j;
			}
			else if (mas[i][j] != '_') {
				coord.push_back({ i, j });
			}
		}
	}
	mas[x][y] = '_';
	dfs(0, x + 1, y + 1);
	dfs(1, x - 1, y - 1);
	dfs(2, x + 1, y - 1);
	dfs(3, x - 1, y + 1);
	sort(vec.begin(), vec.end());
	vector<pair<int, int>> ans;
	int fi = vec[0].first, se = vec[0].second;
	mas[x + fi * dxx[se]][y + fi * dyy[se]] = '_';
	vec.clear();
	int stx = x + (fi)*dxx[se], sty = y + (fi)*dyy[se];
	vec.clear();
	while (vec.empty()) {
		stx += dxx[se];
		sty += dyy[se];
		dfs(0, stx + 1, sty + 1);
		dfs(1, stx - 1, sty - 1);
		dfs(2, stx + 1, sty - 1);
		dfs(3, stx - 1, sty + 1);
	}
	ans.push_back({ stx, sty });
	sort(vec.begin(), vec.end());
	ans.push_back({ (vec[0].first + 1) * dxx[vec[0].second] + stx,
		(vec[0].first + 1) * dyy[vec[0].second] + sty});
	for (int i = 0; i < 2; ++i) {
		cout << ans[i].first << " " << ans[i].second << "\n";
	}
	return 0;
}