#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
using ll = long long;

const int inf = 1e9 + 7;

int mas[1010][1010];
int dx[] = { 0, -1, -1, -1, 0, 0, 1, 1, 1 };
int dy[] = { 0, -1, 0, 1, -1, 1, -1, 0, 1 };

int n, m;

bool is(int x, int y) {
	if (x < 1 || x > n || y > m || y < 1) return false;
	else return true;
}

int ans = 0;

void to(int x, int y, int& d) {
	if (d == 1) {
		if (x == 1 && y == 1) d = 7;
		else if (x == 1) d = 4;
		else d = 5;
		return;
	}
	if (d == 3) {
		if (x == 1 && y == m) d = 4;
		else if (x == 1) d = 7;
		else d = 2;
		return;
	}
	if (d == 6) {
		if (x == n && y == 1) d = 5;
		else if (y == 1) d = 7;
		else d = 2;
		return;
	}
	if (d == 8) {
		if (x == n && y == m) d = 2;
		else if (x == n) d = 5;
		else d = 4;
		return;
	}
	if (d == 2) {
		d = 6;
		return;
	}
	if (d == 7) {
		d = 3;
		return;
	}
	if (d == 4) {
		d = 8;
		return;
	}
	if (d == 5) {
		d = 1;
		return;
	}
}

void dfs(int x, int y, int d, int hoop, int dist = 0) {
	if (dist % hoop == 0 && mas[x][y] == -inf) return;
	if (dist % hoop == 0) {
		ans += mas[x][y];
		mas[x][y] = -inf;
	}
	if (!is(x + dx[d], y + dy[d])) to(x, y, d);
	dfs(x + dx[d], y + dy[d], d, hoop, dist + 1);
}

signed main() {
	cin >> n >> m;
	for (int i = 0; i < n + 2; ++i) {
		for (int j = 0; j < m + 2; ++j) {
			if (!is(i, j)) mas[i][j] = inf;
			else cin >> mas[i][j];
		}
	}
	int stx, sty;
	cin >> stx >> sty;
	int d, hoop;
	cin >> d >> hoop;
	dfs(stx, sty, d, hoop);
	cout << ans << "\n";
	return 0;
}