# ТИ, ЭП, Б, Е

class Building:
    def __init__(self, cost, time, period, out, r_cost, r_period):
        self.cost = cost
        self.time = time
        self.period = period
        self.out = out
        self.r_cost = r_cost
        self.r_period = r_period


buildings = {
    1: Building((8, 3, 10, 0), 5, 2, (2, 0, 5, 0), (3, 0, 0, 0), 5),
    2: Building((5, 0, 8, 0), 5, 5, (0, 0, 0, 7), (0, 0, 2, 0), 10),
    3: Building((10, 6, 10, 0), 10, 10, (0, 6, 0, 0), (2, 0, 0, 0), 18),
    4: Building((8, 4, 8, 0), 8, 8, (0, 0, 8, 0), (1, 1, 0, 0), 12),
}


class RunningBuilding:
    def __init__(self, id, f_time):
        self.id = id
        self.f_time = f_time

    def is_out_time(self, t):
        dt = t - self.f_time
        if dt <= 0:
            return False
        return dt % self.building().period == 0

    def is_pay_time(self, t):
        dt = t - self.f_time
        if dt <= 0:
            return False
        return dt % self.building().r_period == 0

    def building(self):
        return buildings[self.id]

    def __repr__(self):
        return f'id:{self.id}, f_time:{self.f_time}'


X = int(input())
Y = int(input())

building_q = []
for i in range(4):
    for _ in range(5):
        t = int(input())
        #t -= 1
        if t == 0:
            continue
        building_q.append((t, i + 1))
    #print(building_q, i)
building_q = list(sorted(building_q))
running_b = []
res = [30, 30, 30, 30]
#print('asd')
last_T = 0
for T in range(1, 101):

    #print(T, res, running_b, building_q)
    ex = False
    for r in res:
        if r <= 0:
            ex = True
    if ex:
        break
    if T % 10 == 0:
        for i in range(4):
            res[i] += X

    for b in running_b:
        if b.is_out_time(T):
            for i in range(4):
                res[i] += b.building().out[i]

    for b in running_b:
        if b.is_pay_time(T):
            for i in range(4):
                res[i] -= b.building().r_cost[i]

    while len(building_q) > 0 and building_q[0][0] == T:
        #print('a')
        id = building_q[0][1]
        for i in range(4):
            res[i] -= buildings[id].cost[i]
        running_b.append(
            RunningBuilding(id, T + buildings[id].time - 1)
        )
        del building_q[0]

    for i in range(4):
        res[i] -= Y

    last_T = T

print(last_T, *res, sep='\n')
"""
1
40
1
20
70
0
0
50
0
0
0
0
90
0
0
0
0
60
70
0
0
0
"""
"""
40
1
0
0
0
0
0
0
0
0
0
0
0
0
0
0
0
0
0
0
0
0
"""