#include <bits/stdc++.h>

using namespace std;

#define all(x) x.begin(), x.end()
#define x first
#define y second
#define log_2(x) (63-__builtin_clzll(x))
#define set_sum(x) (__builtin_popcountll(x))
#define mp(x, y) make_pair(x, y)

typedef long long int ll;
typedef long long unsigned int ull;
typedef long double ld;
#define int ll
typedef const int ci;
typedef uint32_t uint;
typedef pair<int, int> pii;
typedef pair<ld, ld> pld;
typedef vector<int> vi;
typedef vector<vector<int>> vvi;

const int INF = INT64_MAX;
const int MaxN = (1 << 20) + 5;

vector<pii> get_pts(pii pos, pii end) {
    vector<pii> ans;

    pii tmp = pos;
    bool visited = false;
    while (tmp.x < 7 && tmp.y < 7) {
        pii cur = mp(++tmp.x, ++tmp.y);
        if (visited) ans.emplace_back(cur);
        else if (cur == end) visited = true;
    }

    tmp = pos, visited = false;
    while (tmp.x < 7 && tmp.y > 0) {
        pii cur = mp(++tmp.x, --tmp.y);
        if (visited) ans.emplace_back(cur);
        else if (cur == end) visited = true;
    }

    tmp = pos, visited = false;
    while (tmp.x > 0 && tmp.y < 7) {
        pii cur = mp(--tmp.x, ++tmp.y);
        if (visited) ans.emplace_back(cur);
        else if (cur == end) visited = true;
    }

    tmp = pos, visited = false;
    while (tmp.x > 0 && tmp.y > 0) {
        pii cur = mp(--tmp.x, --tmp.y);
        if (visited) ans.emplace_back(cur);
        else if (cur == end) visited = true;
    }
    return ans;
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    char pl;
    cin >> pl;
    pii p1 = {-1, -1}, p2, d;
    for (int i = 0; i < 8; ++i) {
        for (int j = 0; j < 8; ++j) {
            char cur;
            cin >> cur;
            if (cur == 'B' || cur == 'W') {
                d = {i, j};
            } else if (cur != '_') {
                if (p1.x == -1) p1 = {i, j};
                else p2 = {i, j};
            }
        }
    }

    vector<pii> a = get_pts(d, p1), b;
    if (!a.empty()) {
        for (pii &i: a) {
            b = get_pts(i, p2);
            if (!b.empty()) {
                cout << i.x + 1 << ' ' << i.y + 1 << '\n' << b[0].x + 1 << ' ' << b[0].y + 1;
                return 0;
            }
        }
    }

    a = get_pts(d, p2);
    for (pii &i: a) {
        b = get_pts(i, p1);
        if (!b.empty()) {
            cout << i.x + 1 << ' ' << i.y + 1 << '\n' << b[0].x + 1 << ' ' << b[0].y + 1;
            return 0;
        }
    }
    return 0;
}