#include <iostream>
#include <vector> 
#include <algorithm>

using namespace std;

void print_v(vector <int>& a) {
	for (int i : a) {
		cout << i << ' ';
	}
	cout << endl;
}

string bin(int m, int n) {
	string s = "";
	while (m > 0) {
		if (m % 2 == 1) {
			s = '1' + s;
		}
		else {
			s = '0' + s;
		}
		m /= 2;
	}
	string t = "";
	for (int i = 0; i < n - (int)s.size(); ++i) {
		t += '0';
	}
	return t + s;
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int n;
	cin >> n;
	vector <pair< vector <int>, vector <int>>> a(n);
	vector <pair< vector <int>, vector <int>>> b(n);
	vector <int> norm = { 1, 1, 1 };
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < 9; ++j) {
			int x;
			cin >> x;
			if (j < 3) {
				a[i].first.push_back(x);
				b[i].second.push_back(x);
			}
			else if (j > 5) {
				a[i].second.push_back(x);
				b[i].first.push_back(x);
			}
		}
		reverse(b[i].first.begin(), b[i].first.end());
		reverse(b[i].second.begin(), b[i].second.end());
	}
	vector <int> perm;
	for (int i = 0; i < n; ++i) perm.push_back(i);
	vector <int> ans;
	int f = 0;
	while (next_permutation(perm.begin(), perm.end())) {
		if (f == 1) break;
		for (int mask = 0; mask < (1 << n); ++mask) {
			string s = bin(mask, n);
			vector <pair< vector <int>, vector <int>>> t;
			for (int i = 0; i < n; ++i) {
				if (s[i] == '0') {
					t.push_back(a[perm[i]]);
				}
				else {
					t.push_back(b[perm[i]]);
				}
			}
			if (t[0].second != norm || t[n - 1].first != norm) {
				continue;
			}
			else {
				int c = 0;
				for (int i = 1; i < n; ++i) {
					if (c == 1) break;
					for (int j = 0; j < 3; ++j) {
						if (t[i].second[j] == t[i - 1].first[j]) {
							c = 1;
							break;
						}
					}
				}
				if (c == 0) {
					f = 1;
					ans = perm;
					break;
				}
			}
		}
	}

	for (int i = 0; i < n; ++i) perm[i] = i;
	for (int mask = 0; mask < (1 << n); ++mask) {
		string s = bin(mask, n);
		vector <pair< vector <int>, vector <int>>> t;
		for (int i = 0; i < n; ++i) {
			if (s[i] == '0') {
				t.push_back(a[perm[i]]);
			}
			else {
				t.push_back(b[perm[i]]);
			}
		}
		if (t[0].second != norm || t[n - 1].first != norm) {
			continue;
		}
		else {
			int c = 0;
			for (int i = 1; i < n; ++i) {
				if (c == 1) break;
				for (int j = 0; j < 3; ++j) {
					if (t[i].second[j] == t[i - 1].first[j]) {
						c = 1;
						break;
					}
				}
			}
			if (c == 0) {
				for (int i = 0; i < n; ++i) cout << i + 1 << ' ';
				return 0;
			}
		}
	}
	
	for (int i : ans) {
		cout << i + 1 << ' ';
	}
	//      !!!   -  !!
}