#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <algorithm>
#include <cmath>
#include <map>
#include <fstream>
#include <queue>

using ll = long long;
using ull = unsigned long long;
using ld = long double;

struct event{
    ll tok = 0, elek = 0, beton = 0, food = 0;
};

int main() {
    ll xx, y;
    std::cin>>xx>>y;
    ll tok = 30, elek = 30, beton = 30, food = 30;
    std::vector <event> a(101);
    for(ll i = 10; i <= 100; i += 10){
        a[i].beton += xx;
        a[i].tok += xx;
        a[i].elek += xx;
        a[i].food += xx;
    }

    for(ll i = 1; i <= 100; ++i){
        a[i].beton -= y;
        a[i].tok -= y;
        a[i].elek -= y;
        a[i].food -= y;
    }

    for(ll j = 0; j < 5; ++j){
        ll x;
        std::cin>>x;
        if(x != 0){
            a[x].tok -= 8;
            a[x].elek -= 3;
            a[x].beton -= 10;
            for(ll i = x + 4 + 2; i <= 100; i += 2){
                a[i].beton += 5;
                a[i].tok += 2;
            }
            for(ll i = x + 4 + 5; i <= 100; i += 5){
                a[i].tok -= 3;
            }
        }
    }

    for(ll j = 0; j < 5; ++j){
        ll x;
        std::cin>>x;
        if(x != 0){
            a[x].tok -= 5;
            a[x].beton -= 8;
            for(ll i = x + 4 + 5; i <= 100; i += 5){
                a[i].food += 7;
            }
            for(ll i = x + 4 + 10; i <= 100; i += 10){
                a[i].beton -= 2;
            }
        }
    }


    for(ll j = 0; j < 5; ++j){
        ll x;
        std::cin>>x;
        if(x != 0){
            a[x].tok -= 10;
            a[x].elek -= 6;
            a[x].beton -= 10;
            for(ll i = x + 9 + 10; i <= 100; i += 10){
                a[i].elek += 6;
            }
            for(ll i = x + 4 + 18; i <= 100; i += 18){
                a[i].tok -= 2;
            }
        }
    }

    for(ll j = 0; j < 5; ++j){
        ll x;
        std::cin>>x;
        if(x != 0){
            a[x].tok -= 8;
            a[x].elek -= 4;
            a[x].beton -= 8;
            for(ll i = x + 7 + 8; i <= 100; i += 8){
                a[i].beton += 8;
            }
            for(ll i = x + 7 + 12; i <= 100; i += 12){
                a[i].tok -= 1;
                a[i].elek -= 1;
            }
        }
    }

    for(ll i = 1; i <= 100; ++i){
        beton += a[i].beton;
        tok += a[i].tok;
        elek += a[i].elek;
        food += a[i].food;
        if(beton <= 0 || food <= 0 || tok <= 0 || elek <= 0){
            std::cout<< i << "\n";
            std::cout<<tok << "\n";
            std::cout<<elek << "\n";
            std::cout<<beton << "\n";
            std::cout<<food;
            return 0;
        }
    }
    std::cout<<"100\n";
    std::cout<<tok << "\n";
    std::cout<<elek << "\n";
    std::cout<<beton << "\n";
    std::cout<<food;
}

