#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <algorithm>
#include <cmath>
#include <map>
#include <fstream>
#include <queue>

using ll = long long;
using ull = unsigned long long;
using ld = long double;

ll fl = 0, n = 0;
std::vector <std::vector <std::vector <ll>>> a;

bool gl3(std::vector <std::vector <ll>> up, std::vector <std::vector <ll>> down){
    // gl - 3
    ll fla = 1;
    for(ll i = 0; i < 2; ++i){
        for(ll j = 0; j < 2; ++j){
            if(up[i][j] == down[i][j]){
                fla = 0;
            }
        }
    }
    return fla;
}

std::vector <std::vector <ll>> ugl3(std::vector <std::vector <ll>> up, std::vector <std::vector <ll>> down){
    std::vector <ll> _(3, 1);
    std::vector <std::vector <ll>> tmp(3, _);
    return tmp;
}

bool gl2(std::vector <std::vector <ll>> up, std::vector <std::vector <ll>> down){
    // gl - 2
    ll fla = 1;
    for(ll i = 0; i < 2; ++i){
        for(ll j = 0; j < 3; ++j){
            if((up[i + 1][j] == down[i][j])){
                fla = 0;
            }
        }
    }
    for(ll j = 0; j < 3; ++j){
            if(down[2][j] == 0){
                fla = 0;
            }
        }
    return fla;
}

std::vector <std::vector <ll>> ugl2(std::vector <std::vector <ll>> up, std::vector <std::vector <ll>> down){
    std::vector <ll> _(3, 1);
    std::vector <std::vector <ll>> tmp(3, _);
    for(ll i = 0; i < 2; ++i){
        for(ll j = 0; j < 3; ++j){
            tmp[i][j] = up[i + 1][j] | down[i][j];
        }
    }
    for(ll j = 0; j < 3; ++j){
        tmp[0][j] = up[0][j];
    }
    return tmp;
}

bool gl1(std::vector <std::vector <ll>> up, std::vector <std::vector <ll>> down){
    //gl - 1
    ll fla = 1;
    for(ll j = 0; j < 3; ++j){
        if((up[2][j] == down[0][j])){
                fla = 0;
        }
    }
    for(ll i = 1; i < 3; ++i){
        for(ll j = 0; j < 3; ++j){
            if(down[i][j] == 0){
                fla = 0;
            }
        }
    }
    return fla;
}

std::vector <std::vector <ll>> ugl1(std::vector <std::vector <ll>> up, std::vector <std::vector <ll>> down){
    std::vector <ll> _(3, 1);
    std::vector <std::vector <ll>> tmp(3, _);
    for(ll i = 0; i < 2; ++i){
        for(ll j = 0; j < 3; ++j){
            tmp[i][j] = up[i][j];
        }
    }
    return tmp;
}

void get(std::vector <std::vector <ll>> last, std::vector <ll> pos, std::vector <ll> used){
    if(fl){
        return;
    } else if(pos.size() == 0){
        for(ll i = 0; i < n; ++i){
            if(a[i][2][0] == 1 || a[i][2][1] == 1 || a[i][2][2] == 1){
                pos.push_back(i);
                used[i] = 1;
                get(a[i], pos, used);
                pos.pop_back();
                used[i] = 0;
            }
        }
    } else if(pos.size() == n){
        if(last[0][0] == 1 || last[0][1] == 1 || last[0][2] == 1){
            fl = 1;
            for(auto i : pos){
                std::cout<<i + 1 << ' ';
            }
            return;
        } else{
            return;
        }
    } else {
        for(ll i = 0; i < n; ++i){
            if(!used[i]){
                    if(gl3(a[i], last)){
                        pos.push_back(i);
                        used[i] = 1;
                        get(ugl3(a[i], last), pos, used);
                        pos.pop_back();
                        used[i] = 0;
                    } else if(gl2(a[i], last)){
                        pos.push_back(i);
                        used[i] = 1;
                        get(ugl2(a[i], last), pos, used);
                        pos.pop_back();
                        used[i] = 0;
                    } else if(gl1(a[i], last)){
                        pos.push_back(i);
                        used[i] = 1;
                        get(ugl1(a[i], last), pos, used);
                        pos.pop_back();
                        used[i] = 0;
                    }
            }
        }
    }
}

int main() {
    std::cin>>n;
    std::vector <ll> _(3, 0);
    std::vector <std::vector <ll>> __(3, _);
    a.resize(n, __);
    for(ll i = 0; i < n; ++i){
        for(ll j = 0; j < 3; ++j){
            for(ll q = 0; q < 3; ++q){
                std::cin>>a[i][j][q];
            }
        }
    }
    std::vector <ll> used(10, 0);
    std::vector <ll> qwe;
    get(__, qwe, used);
}

