from itertools import permutations


n = int(input())

blocks = []
starts = []

for i in range(n):
    block = []
    for j in range(3):
        block.append(list(map(int, input().split())))
    blocks.append(block)

    if block[0] == [1, 1, 1] or block[-1] == [1, 1, 1]:
        starts.append(i)

start = min(starts)
end = max(starts)
indexes = [i for i in range(n) if i != start and i != end]

def fit(one, second):
    for i in range(3):
        if [one[i], second[i]].count(1) != 1:
            return False
    return True

p = []

for perm in permutations(indexes):
    bindexes = list(perm)
    ans = True
    prev = []
    if blocks[start][-1] == [1, 1, 1]:
        prev = blocks[start][0]
    else:
        prev = blocks[start][-1]

    for bindex in bindexes:
        if fit(prev, blocks[bindex][-1][::-1]):
            prev = blocks[bindex][0][::-1]
        elif fit(prev, blocks[bindex][0]):
            prev = blocks[bindex][-1]
        else:
            ans = False
            break

    if ans:
        if blocks[end][-1] == [1, 1, 1] and fit(blocks[end][0], prev):
            ans = True
        elif blocks[end][0] == [1, 1, 1] and fit(blocks[end][-1][::-1], prev):
            ans = True
        else:
            ans = False

    if ans:
        p = [start] + bindexes + [end]

for i in p:
    print(i + 1, end=" ")