direction, power = [int(x) for x in input().split()]
direction_x = 0
direction_y = 0

if direction == 225:
    direction_x = -1
    direction_y = -1
elif direction == 315:
    direction_x = 1
    direction_y = -1
elif direction == 135:
    direction_x = -1
    direction_y = 1
elif direction == 45:
    direction_x = 1
    direction_y = 1

N = int(input())

map_min_x = None
map_min_y = None
map_max_x = None
map_max_y = None

# Box: [range(min_x, max_x + 1), range(min_y, max_y + 1), n]
boxes: list[list[list[int], int]] = []
for _ in range(N):
    min_x, max_y, max_x, min_y, n = [int(x) for x in input().split()]
    boxes.append([list(range(min_x, max_x + 1)), list(range(min_y, max_y + 1)), n])
    if map_min_x is None or min_x < map_min_x:
        map_min_x = min_x
    if map_max_x is None or max_x > map_max_x:
        map_max_x = max_x
    if map_min_y is None or min_y < map_min_y:
        map_min_y = min_y
    if map_max_y is None or max_y > map_max_y:
        map_max_y = max_y

cord_x, cord_y = [int(x) for x in input().split()]

point_map = {}
for x in range(map_min_x, map_max_x + 1):
    for y in range(map_min_y, map_max_y + 1):
        point = -1
        for box in boxes:
            if x in box[0] and y in box[1]:
                point = box[2]
        point_map[f"{x},{y}"] = point

for x in range(map_min_x, map_max_x + 1):
    for y in range(map_min_y, map_max_y + 1):
        print(point_map[f"{x},{y}"], end=" ")
    print()

while True:
    if pointer_x == cord_x and pointer_y == cord_y:
        break
    # change direction if near wall
    if direction_x == -1 and pointer_x == 0:
        direction_x = 1
    if direction_x == 1 and pointer_x == M - 1:
        direction_x = -1
    if direction_y == -1 and pointer_y == 0:
        direction_y = 1
    if direction_y == 1 and pointer_y == N - 1:
        direction_y = -1
    # Move
    pointer_x += direction_x
    pointer_y += direction_y


