from itertools import permutations

blocks = []
start, end = [], []

for i in range(int(input())):
    block = [list(map(int, input().split())) for j in range(3)]
    if block[0] == [1, 1, 1]:
        start = (block, i + 1)
    elif block[2] == [1, 1, 1]:
        end = (block, i + 1)
    else:
        blocks.append((block, i + 1))

for perm in permutations(blocks):
    tower = list(zip(*(start[0] + sum(map(lambda x: x[0], perm), []) + end[0])))
    gaps = []
    for row in tower:
        gap = []
        for i in range(len(row) - 1):
            if row[i] == 1 and row[i + 1] == 0:
                gap.append(1)
            elif row[i] == 0 and row[i + 1] == 0:
                gap[-1] += 1
            elif row[i + 1] == 1:
                pass
        gaps.append(gap)

    if gaps[0] == gaps[1] and gaps[1] == gaps[2]:
        print(end[1], *map(lambda x: x[1], perm[::-1]), start[1])
        break

