data = list(map(lambda t: list(map(int, t.split(","))), input().split("_")))
# data = [[1, 2], [2, 2], [3, 3], [2, 3], [1, 1], [1, 3], [2, 2], [3, 3], [1, 3]]
# data = [[2, 1], [1, 1], [3, 2], [3, 1], [2, 2], [3, 2], [3, 2], [1, 2], [2, 3]]


menu = {
    1: {
        "products": [
            {
                "name": "макароны",
                "price": 50
            },
            {
                "name": "овощи",
                "price": int(30 * 0.5)
            },
            {
                "name": "соус",
                "price": int(60 * 0.2)
            }
        ],
        "duration": 60,
        "cost": 370
    },
    2: {
        "products": [
            {
                "name": "блины",
                "price": 45
            },
            {
                "name": "соус",
                "price": int(60 * 0.2)
            }
        ],
        "duration": 30,
        "cost": 200
    },
    3: {
        "products": [
            {
                "name": "овощи",
                "price": int(30 * 1.5)
            },
            {
                "name": "соус",
                "price": 60
            }
        ],
        "duration": 60,
        "cost": 400
    }
}


moneys = []
for i in data:
    time = 0
    spend = 0
    earned = 0
    for j in i:
        a = menu[j]
        time += a["duration"]
        spend += sum(k["price"] for k in a["products"])
        earned += a["cost"]
    moneys.append((earned - spend, time))


ret = []
time_duration = 22 * 60 - 8 * 60
timer = 0
for i in sorted(moneys, key=lambda t: t[0])[::-1]:
    if timer + i[1] <= time_duration:
        ret.append(i[0])
        timer += i[1]
print(sum(ret))
print(len(ret) == len(data))
