#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
const ll infll = 1e9;


void solve() {
    int n, m; cin >> n >> m;
    vector<vector<ll>> v(n, vector<ll>(m));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> v[i][j];
        }
    }
    vector<pii> dist = {
        {-1, 0}, {-1, 1}, {0, 1}, {1, 1}, {1, 0}, {1, -1}, {0, -1}, {-1, -1}, {-1, 0}
    };
    map<int, int> start = {
        {1, 7}, {2, 0}, {3, 1}, {4, 6}, {5, 2}, {6, 5}, {7, 4}, {8, 3}
    };

    int ci, cj; cin >> ci >> cj; ci--, cj--;
    int curd; cin >> curd; curd = start[curd];
    int di = dist[curd].first, dj = dist[curd].second;
    int i = ci, j = cj;

    ll res = 0;
    while (1) {
        if (v[i][j] == infll) {
            break;
        }
        res += v[i][j];
        v[i][j] = infll;

        int co = 0;
        while (co < 6) {
            int ni = i + di, nj = j + dj;
            if (0 <= ni && ni < n && 0 <= nj && nj < m) {
                break;
            }

            if (!(0 <= ni && ni < n)) {
                di *= -1;
            }
            if (!(0 <= nj && nj < m)) {
                dj *= -1;
            }
            for (int i = 0; i < 8; ++i) {
                if (dist[i].first == di && dist[i].second == dj) {
                    di = dist[i + 1].first;
                    dj = dist[i + 1].second;
                    break;
                }
            }
            co++;
        }
        if (co > 1) {
            break;
        }

        i = i + di, j = j + dj;
    }
    cout << res << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    // freopen("input.txt", "rt", stdin);

    solve();

    return 0;
}
