ingredients_cost = {
    'm': 50,
    'o': 30,
    's': 60,
    'b': 45
}
products_ingredients = {
    1: [
        ('m', 1),
        ('o', 0.5),
        ('s', 0.2)
    ],
    2: [
        ('b', 1),
        ('s', 0.2),
    ],
    3: [
        ('o', 1.5),
        ('s', 1)
    ]
}

products_time = {
    1: 1 * 60,
    2: 30,
    3: 1 * 60
}

product_cost = {
    1: 370,
    2: 200,
    3: 400
}
products_c = {
    1: -sum(
        ingredients_cost[ingredient] * count for ingredient, count in products_ingredients[1]
    ) + product_cost[1],
    2: -sum(
        ingredients_cost[ingredient] * count for ingredient, count in products_ingredients[2]
    ) + product_cost[2],
    3: -sum(
        ingredients_cost[ingredient] * count for ingredient, count in products_ingredients[3]
    ) + product_cost[3],
}

cost, time = 0, 8 * 60
meals = input()
meals_info = []
for meal in meals.split('_'):
    p1, p2 = map(int, meal.split(','))
    meals_info.append((
        (products_c[p1] + products_c[p2]) / (products_time[p1] + products_time[p2]),
        products_c[p1] + products_c[p2],
        products_time[p1] + products_time[p2]
    ))

is_res = True
for meal in sorted(meals_info)[::-1]:
    if time + meal[2] > 22 * 60:
        is_res = False
    else:
        time += meal[2]
        cost += meal[1]
print(int(cost))
print(is_res)
