from math import *

def sign(x):
    return x > 0

k = pi / 180
angle, max_intense = map(int, input().split())
dx, dy = round(cos(angle * k)), round(sin(angle * k))

n = int(input())
mirs = []
for _ in range(n):
    mirs.append(
        tuple(int(i) for i in input().split())
    )
endx, endy = (int(i) for i in input().split())


def in_mir(px, py):
    for m in mirs:
        sx, sy, ex, ey = m[0], m[1], m[2], m[3]
        if min(sx, ex) <= px <= max(sx, ex) and min(sy, ey) <= py <= max(sy, ey) and (sx - px) * (sy - ey) == (sy - py) * (sx - ex):
            return True
    return False

px, py = 0, 0
cur_intense = max_intense
while True:
    nx, ny = px + dx, py + dy
    if nx == endx and ny == endy:
        print(int(cur_intense))
        break

    if in_mir(nx, ny):
        block_hit = 0
        sx, sy, ex, ey = 0, 0, 0, 0
        for m in mirs:
            sx, sy, ex, ey = m[0], m[1], m[2], m[3]
            if min(sx, ex) <= nx <= max(sx, ex) and min(sy, ey) <= ny <= max(sy, ey) and (sx - nx) * (sy - ey) == (sy - ny) * (sx - ex):
                block_hit = m
                break

        if sx == ex: dx *= -1
        elif sy == ey: dy *= -1
        elif sign(ex - sx) == sign(ey - sy):
            dx, dy = dy, -dx
        else:
            dx, dy = -dy, -dx

        cur_intense = cur_intense * (100 - block_hit[4]) / 100
        if cur_intense < 0.1 * max_intense:
            print(block_hit[0], block_hit[1], block_hit[2], block_hit[4], int(cur_intense))
            break
    px, py = nx, ny

