#include <iostream>
#include <vector>

#define int long long

using namespace std;

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    char c;
    cin >> c;

    vector<vector<char>> m(8, vector<char>(8));
    for (auto& i : m) for (auto& j : i) cin >> j;

    pair<int, int> b, w;
    bool isbQueen;
    bool iswQueen;

    for (int i = 0; i < 8; ++i) {
        for (int j = 0; j < 8; ++j) {
            if (m[i][j] == 'b') {
                b = {i, j};
                isbQueen = false;
            } else if (m[i][j] == 'B') {
                b = {i, j};
                isbQueen = true;
            } else if (m[i][j] == 'w') {
                w = {i, j};
                iswQueen = false;
            } else if (m[i][j] == 'W') {
                w = {i, j};
                iswQueen = true;
            }
        }
    }

    if (c == 'b') {
        if (isbQueen) {
            int idiff = (w.first - b.first);
            int jdiff = (w.second - b.second);
            if (idiff >= 0) {
                if (jdiff >= 0) {
                    if (idiff == jdiff && w.first + 1 < 8 && w.second + 1 < 8) {
                        cout << b.first + 1 << ' ' << b.second + 1;
                    } else {
                        cout << 0;
                    }
                } else {
                    if (idiff == -jdiff && w.first + 1 < 8 && w.second - 1 >= 0) {
                        cout << b.first + 1 << ' ' << b.second + 1;
                    } else {
                        cout << 0;
                    }
                }
            } else {
                if (jdiff >= 0) {
                    if (-idiff == jdiff && w.first - 1 >= 0 && w.second + 1 < 8) {
                        cout << b.first + 1 << ' ' << b.second + 1;
                    } else {
                        cout << 0;
                    }
                } else {
                    if (-idiff == -jdiff && w.first - 1 >= 0 && w.second - 1 >= 0) {
                        cout << b.first + 1 << ' ' << b.second + 1;
                    } else {
                        cout << 0;
                    }
                }
            }
        } else {
            if (b.first + 1 == w.first && b.first + 2 < 8 && (b.second + 1 == w.second && b.second + 2 < 8 || b.second - 1 == w.second && b.second - 2 >= 0)) {
                cout << b.first + 1 << ' ' << b.second + 1 << '\n';
            } else {
                cout << 0;
            }
        }
    } else {
        if (iswQueen) {
            int idiff = (b.first - w.first);
            int jdiff = (b.second - w.second);
            if (idiff >= 0) {
                if (jdiff >= 0) {
                    if (idiff == jdiff && b.first + 1 < 8 && b.second + 1 < 8) {
                        cout << w.first + 1 << ' ' << w.second + 1;
                    } else {
                        cout << 0;
                    }
                } else {
                    if (idiff == -jdiff && b.first + 1 < 8 && b.second - 1 >= 0) {
                        cout << w.first + 1 << ' ' << w.second + 1;
                    } else {
                        cout << 0;
                    }
                }
            } else {
                if (jdiff >= 0) {
                    if (-idiff == jdiff && b.first - 1 >= 0 && b.second + 1 < 8) {
                        cout << w.first + 1 << ' ' << w.second + 1;
                    } else {
                        cout << 0;
                    }
                } else {
                    if (-idiff == -jdiff && b.first - 1 >= 0 && b.second - 1 >= 0) {
                        cout << w.first + 1 << ' ' << w.second + 1;
                    } else {
                        cout << 0;
                    }
                }
            }
        } else {
            if (w.first - 1 == b.first && w.first - 2 >= 0 && (w.second + 1 == b.second && w.second + 2 < 8 || w.second - 1 == b.second && w.second - 2 >= 0)) {
                cout << w.first + 1 << ' ' << w.second + 1 << '\n';
            } else {
                cout << 0;
            }
        }
    }
 
    return 0;
}
