#include <iostream>
#include <vector>

#define int long long

using namespace std;

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;

    vector<int> a(n);
    vector<int> b(n);

    for (auto& i : a) cin >> i;
    for (auto& i : b) cin >> i;

    vector<int> c;
    for (int i = 0; i < n; ++i) {
        if (a[i] - b[i] > 0) c.emplace_back(a[i] - b[i]);
    }

    n = c.size();

    vector<int> dp(n, 0);
    dp[0] = 1;
    for (int i = 1; i < n; ++i) {
        for (int j = 0; j < i; ++j) {
            if (c[j] < c[i]) dp[i] = max(dp[i], dp[j]);
        }
        dp[i]++;
    }

    int res = 0;
    for (int i = 0; i < n; ++i) res = max(res, dp[i]);

    cout << res;
 
    return 0;
}
