﻿#include <iostream>
#include <vector>
#include <cmath>
using namespace std;
vector<int> res;
vector<vector<int>> sp;
int n;

void dfs(int cur1, int st1, vector<bool> used, vector<int> way) {
	if (res.size() != 0)
		return;
	used[cur1] = true;
	bool flag = false;
	for (int i = 0; i < n; i++)
	{
		if (!used[i]) {
			if (sp[cur1][2 - st1] + sp[i][0] == 7) {
				vector<int> way1(way.size());
				for (int i = 0; i < way.size(); i++) way1[i] = way[i];
				way1.push_back(cur1);
				dfs(i, 1, used, way1);
			}
			if (sp[cur1][2 - st1] + sp[i][3] == 7) {
				vector<int> way2(way.size());
				for (int i = 0; i < way.size(); i++) way2[i] = way[i];
				way2.push_back(cur1);
				dfs(i, 0, used, way2);
			}
			flag = true;
		}
	}
	if (!flag) {
		res = way;
		res.push_back(cur1);
	}
}

int main()
{
	cin >> n;
	sp.resize(n, vector<int>(4));
	int cur = -1, st = 0;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < 3; j++) {
			int cou1 = 0, cou2 = 0, x;
			for (int t = 0; t < 3; t++) {
				cin >> x;
				cou1 += pow(2, 2 - t) * x;
				cou2 += pow(2, t) * x;
			}
			if (j != 1) {
				sp[i][j / 2] = cou1;
				sp[i][j / 2 + 2] = cou2;
				if (cou1 == 7 && cur == -1) {
					cur = i;
					if (j == 0) st = 1;
					else st = 0;
				}
			}
		}
	}
	vector<bool> used(n, false);
	vector<int> way;
	dfs(cur, st, used, way);
	for (int i = 0; i < n; i++) {
		cout << res[i] + 1 << ' ';
	}
	return 0;

}
