#include<iostream>
#include<vector>
#include<string>

using namespace std;

vector<vector<int>>mx;
int x, y;
int n, m, t;

int ndr(int dr) {
	if (x == 0 && y == 0) {
		return 8;
	}
	if (x == m-1 && y == 0) {
		return 6;
	}
	if (x == 0 && y == n-1) {
		return 3;
	}
	if (x == m-1 && y == n-1) {
		return 1;
	}

	if (y == 0) {
		if (dr == 3)
			return 8;
		if (dr == 1)
			return 6;
	}
	if (x == 0) {
		if (dr == 6)
			return 8;
		if (dr == 1)
			return 3;
	}
	if (x == m-1) {
		if (dr == 3)
			return 1;
		if (dr == 8)
			return 6;
	}
	if (y == n-1) {
		if (dr == 6)
			return 1;
		if (dr == 8)
			return 3;
	}
	return dr;
}

void move(int dr) {
	if (dr == 1) {
		x--;
		y--;
		return;
	}
	if (dr == 3) {
		x++;
		y--;
		return;
	}
	if (dr == 8) {
		x++;
		y++;
		return;
	}
	if (dr == 6) {
		x--;
		y++;
		return;
	}
}

int main() {
	long long sum = 0;

	cin >> n >> m;
	for (int i = 0; i < n; i++) {
		mx.push_back({});
		for (int j = 0; j < m; j++) {
			cin >> t;
			mx[i].push_back(t);
		}
	}

	cin >> y >> x;
	int dir;
	cin >> dir;

	if (n == 1 or m == 1) {
		cout << mx[y][x];
		return 0;
	}

	if (dir == 2 or dir == 7) {
		for (int i = 0; i < n; i++) {
			sum += mx[i][x];
		}
		cout << sum;
		return 0;
	}
	if (dir == 4 or dir == 5) {
		for (int i = 0; i < m; i++) {
			sum += mx[y][i];
		}
		cout << sum;
		return 0;
	}
	dir = ndr(dir);
	int inx = x, iny = y, ind = dir;

	sum += mx[y][x];
	mx[y][x] = 0;
	dir = ndr(dir);
	move(dir);
	sum += mx[y][x];
	mx[y][x] = 0;
	dir = ndr(dir);
	move(dir);

	while (true) {
		sum += mx[y][x];
		mx[y][x] = 0;
		dir = ndr(dir);
		if (x == inx && y == iny && dir == ind)
		{
			cout << sum;
			return 0;
		}
		move(dir);
		if (x == inx && y == iny && dir == ind)
		{
			cout << sum;
			return 0;
		}
	}

	return 0;
}