#include <iostream>
#include <vector>
using namespace std;

#define int long long

void solve() {
	int get, spend;
	cin >> get >> spend;
	int tok = 30, elp = 30, bet = 30, food = 30;
	vector<vector<int>> whenBuild(5);
	for (int i = 0; i < 4; ++i){
		for (int j = 0; j < 5; ++j){
			int a;
			cin >> a;
			if (a){
				whenBuild[i].push_back(a);
			}
		}
	}
	int ans = 0;
	vector<pair<int, int>> toyield; // {id, months}
	vector<pair<int, int>> tobuild; // {id, months}
	vector<pair<int, int>> tospend;
	for (int month = 1; month <= 100; ++month){
		if (month % 10 == 0){
			tok += get;
			elp += get;
			bet += get;
			food += get;
		}
		for (int i = 0; i < 5; ++i){
			for (auto el : whenBuild[i]){
				if (el == month){
					switch (i)
					{
					case 0:
						tobuild.emplace_back(1, 5);
						tok -= 8;
						elp -= 3;
						bet -= 10;
						break;
					case 1:
						tobuild.emplace_back(2, 5);
						bet -= 8;
						tok -= 5;
						break;
					case 2:
						tobuild.emplace_back(3, 10);
						elp -= 6;
						tok -= 10;
						bet -= 10;
						break;
					case 3:
						tobuild.emplace_back(4, 8);
						elp -= 4;
						tok -= 8;
						bet -= 8;
						break;
					}
				}
			}
		}
		for (auto &el : toyield){
			el.second--;
			if (el.second == 0){
				switch (el.first)
				{
				case 1:
					bet += 5;
					tok += 2;
					el.second = 2;
					break;
				case 2:
					food += 7;
					el.second = 5;
					break;
				case 3:
					elp += 6;
					el.second = 10;
					break;
				case 4:
					bet += 8;
					el.second = 8;
					break;
				}
			}
		}
		for (auto &el : tospend){
			el.second--;
			if (el.second == 0){
				switch (el.first)
				{
				case 1:
					tok -= 3;
					el.second = 5;
					break;
				case 2:
					bet -= 2;
					el.second = 10;
					break;
				case 3:
					tok -= 2;
					el.second = 18;
					break;
				case 4:
					tok -= 1;
					elp -= 1;
					el.second = 12;
					break;
				}
			}
		}
		for (int i = 0; i < (int)tobuild.size(); ++i){
			tobuild[i].second--;
			if (tobuild[i].second == 0){
				switch (tobuild[i].first)
				{
				case 1:
					toyield.emplace_back(1, 2);
					tospend.emplace_back(1, 5);
					break;
				case 2:
					toyield.emplace_back(2, 5);
					tospend.emplace_back(2, 10);
					break;
				case 3:
					toyield.emplace_back(3, 10);
					tospend.emplace_back(3, 18);
					break;
				case 4:
					toyield.emplace_back(4, 8);
					tospend.emplace_back(4, 12);
					break;
				}
				tobuild.erase(tobuild.begin() + i);
				i--;
			}
		}
		bet -= spend;
		elp -= spend;
		tok -= spend;
		food -= spend;
		ans = month;
		if (bet <= 0 || elp <= 0 || tok <= 0 || food <= 0){
			break;
		}
	}
	cout << ans << '\n' << tok << '\n' << elp << '\n' << bet << '\n' << food;
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int t = 1;
	// cin >> t;
	while (t--){
		solve();
	}
	return 0;
}
