#include <iostream>
#include <vector>
#include <algorithm>
#include <random>
#include  <chrono>
using namespace std;

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

struct Block
{
	vector<vector<int>> mat;
	int ind;

	Block() {
		mat.assign(3, vector<int>(3, 0));
	};
};

void solve() {
	int n;
	cin >> n;
	vector<Block> a(n);
	int cnt = 0;
	for (int i = 0; i < 3 * n; ++i){
		a[cnt].ind = cnt;
		for (int e = 0; e < 3; ++e){
			int c;
			cin >> c;
			a[cnt].mat[i % 3][e] = c;
		}
		if (i % 3 == 0 && i){
			cnt++;
		}
	}
	vector<int> inds(n);
	for (int i = 0; i < n; ++i) {
		inds[i] = i + 1;
	}
	random_shuffle(inds.begin(), inds.end());
	for (auto el : inds) {
		cout << el << ' ';
	}
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int t = 1;
	// cin >> t;
	while (t--){
		solve();
	}
	return 0;
}
