#include <bits/stdc++.h>

#define rep(i, n) for(int i = 0; i < (n); ++i)
#define rep1(i, n) for(int i = 1; i <= (n); ++i)

using namespace std;
using i64 = long long;

mt19937 rd(chrono::steady_clock::now().time_since_epoch().count());

int a[1000][1000];
bool wasd[1000][1000][3][3], was[1000][1000];
int dxa[] = {-1, 0, +1, -1, +1, -1, 0, +1};
int dya[] = {+1, +1, +1, 0, 0, -1, -1, -1};

void solve(){
    int n, m;
    cin >> n >> m;
    i64 all = 0;
    rep(i, n) rep(j, m){
        cin >> a[i][j];
        all += a[i][j];
        was[i][j] = 0;
        rep(k, 3) rep(e, 3) wasd[i][j][k][e] = 0;
    }
    auto badi = [&](int i) -> bool {
        return !(i >= 0 && i < n);
    };
    auto badj = [&](int j) -> bool {
        return !(j >= 0 && j < m);
    };
    int curi, curj, dir, dx, dy;
    cin >> curi >> curj >> dir;
    --curi, --curj, --dir;
    dx = dxa[dir], dy = dya[dir];
    if(n == 1){
        if(dx != 0){
            cout << all;
        }else{
            cout << a[curi][curj];
        }
        return;
    }
    if(m == 1){
        if(dy != 0){
            cout << all;
        }else{
            cout << a[curi][curj];
        }
        return;
    }
    i64 res = 0;
    while(!wasd[curi][curj][dx][dy]){
        wasd[curi][curj][dx][dy] = 1;
        if(!was[curi][curj]){
            was[curi][curj] = 1;
            res += a[curi][curj];
        }
        if(badi(curi + dy)){
            dy *= -1;
        }
        if(badj(curj + dx)){
            dx *= -1;
        }
        curi += dy, curj += dx;
    }
    cout << res;
}

signed main(){
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    //

#ifdef requiem
    freopen("input.in", "r", stdin);
    freopen("output.out", "w", stdout);
#endif

    int tt = 1;
    // cin >> tt;
    rep(i, tt){
        solve();
    }

    // cerr << fixed << 1.0 * clock() / CLOCKS_PER_SEC;
    return 0;
}
