#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;

#define pii pair<int, int>
#define pll pair<ll, ll>

#define pb push_back
#define ins insert 
#define ers erase 
#define all(a) a.begin(), a.end()
#define accuracy(a) fixed << setprecision(a)
#define endl '\n'

const int INF = 1e9;
const ll LINF = 1e18;

void solve();

signed main()
{
    #ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    #else 
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    #endif

    solve();
    return 0;
}

void solve()
{
    char hod;
    cin >> hod;
    bool white = 0;

    if (hod == 'w') white = 1;
    vector<vector<char> > v(10, vector<char>(10, -1));

    pii b;
    pii w;

    for(int i = 1; i <= 8; ++i) {
        for(int j = 1; j <= 8; ++j) {
            char a;
            cin >> a;
            if (a == '_') v[i][j] = 0;
            else if (a == 'w') v[i][j] = 1;
            else if (a == 'W') v[i][j] = 11;
            else if (a == 'b') v[i][j] = 2;
            else if (a == 'B') v[i][j] = 22;

            if (v[i][j] == 0) continue;
            if (v[i][j] % 2 == 0) {
                b = {i, j};
            } else w = {i, j};
        }
    }

    if (white) {
        if (v[w.first][w.second] == 11) {
            if (abs(b.first - w.first) == abs(w.second - b.second)) {
                // cout << w.first << ' ' << w.second;
                int pos; // 0 1 2 3

                if (b.first < w.first && b.second < w.second) pos = 0;
                if (b.first < w.first && b.second > w.second) pos = 1;
                if (b.first > w.first && b.second < w.second) pos = 3;
                if (b.first > w.first && b.second > w.second) pos = 2;
                bool win = 0;

                if (pos == 0) {
                    if (v[b.first - 1][b.second - 1] == 0) win = 1;
                } else if (pos == 1) {
                    if (v[b.first - 1][b.second + 1] == 0) win = 1;
                } else if (pos == 2) {
                    if (v[b.first + 1][b.second + 1] == 0) win = 1;
                } else{
                    if (v[b.first + 1][b.second - 1] == 0) win = 1;
                }
                
                if (win)  cout << w.first << ' ' << w.second;
                else cout << 0;
            } else cout << 0; 
        } else {    
            bool xcond = (w.first == b.first + 1);
            bool ycond = (b.second == w.second - 1 && v[w.first - 2][w.second - 2] == 0 || b.second == w.second + 1 && v[w.first - 2][w.second + 2] == 0);
            if (xcond && ycond) cout << w.first << ' ' << w.second;
            else cout << 0;
        }
    } else {
        if (v[b.first][b.second] == 22) {
            if (abs(b.first - w.first) == abs(w.second - b.second)) {
                int pos; // 0 1 2 3

                if (w.first < b.first && w.second < b.second) pos = 0;
                if (w.first < b.first && w.second > b.second) pos = 1;
                if (w.first > b.first && w.second < b.second) pos = 3;
                if (w.first > b.first && w.second > b.second) pos = 2;
                bool win = 0;

                if (pos == 0) {
                    if (v[w.first - 1][w.second - 1] == 0) win = 1;
                } else if (pos == 1) {
                    if (v[w.first - 1][w.second + 1] == 0) win = 1;
                } else if (pos == 2) {
                    if (v[w.first + 1][w.second + 1] == 0) win = 1;
                } else{
                    if (v[w.first + 1][w.second - 1] == 0) win = 1;
                }
                
                if (win)  cout << b.first << ' ' << b.second;
                else cout << 0;
            } else cout << 0;
        } else {
            bool xcond = (w.first == b.first + 1);
            bool ycond = (w.second == b.second + 1 && v[b.first + 2][b.second + 2] == 0 || w.second == b.second - 1 && v[b.first + 2][w.second - 2] == 0);
            if (xcond && ycond) cout << b.first << ' ' << b.second;
            else cout << 0;
        }
    }
}