#include <iostream>
#include <string>
#include <stdint.h>

/*
1000000
100000
108000
*/

int main() {
    int64_t n, r, x;
    std::cin >> n >> r >> x;

    if(n * r >= x * 12 * 100) {
        std::cout << "False\n0\n";
        return 0;
    }

    uint32_t m = 0;

    int64_t left = 0;

    for(; m < 600 && n > 0; m++) {
        if((m % 12) == 0) {
            if(left > 0) {
                std::cout << "False\n0\n";
                return 0;
            }

            left += n * r;
        }

        left -= x * 100;

        if(left < 0) {
            n += left / 100;
            left = 0;
        }
    }

    if(n > 0) {
        std::cout << "False\n0\n";
        return 0;
    }

    std::cout << "True\n" << m << "\n";

    return 0;
}
