def convert_to_ADEKVATNAYA_direction(old_dir):
    if (old_dir == 2):
        return 1
    if (old_dir == 3):
        return 2
    if (old_dir == 5):
        return 3
    if (old_dir == 8):
        return 4
    if (old_dir == 7):
        return 5
    if (old_dir == 6):
        return 6
    if (old_dir == 4):
        return 7
    if (old_dir == 1):
        return 8
    
def dir_to_change(dir):
    if (dir == 1):
        return (0, -1)
    if (dir == 2):
        return (1, -1)
    if (dir == 3):
        return (1, 0)
    if (dir == 4):
        return (1, 1)
    if (dir == 5):
        return (0, 1)
    if (dir == 6):
        return (-1, 1)
    if (dir == 7):
        return (-1, 0)
    if (dir == 8):
        return (-1, -1)
    
def change_to_dir(change):
    if (change == (0, -1)):
        return 1
    if (change == (1, -1)):
        return 2
    if (change == (1, 0)):
        return 3
    if (change == (1, 1)):
        return 4
    if (change == (0, 1)):
        return 5
    if (change == (-1, 1)):
        return 6
    if (change == (-1, 0)):
        return 7
    if (change == (-1, -1)):
        return 8

def normalize_dir(old_dir):
    while(old_dir < 1):
        old_dir += 8
    while (old_dir > 8):
        old_dir -= 8
    return old_dir

    

n, m = map(int, input().split())

matrix = []

for i in range(n):
    matrix.append(list(map(int, input().split())))

startY, startX = map(lambda x: int(x) - 1, input().split())
direction, step = map(int, input().split())
direction = convert_to_ADEKVATNAYA_direction(direction)
pos = (startX, startY)

def try_reflect():
    global direction
    change = dir_to_change(direction)
    new_position = (pos[0] + change[0], pos[1] + change[1])
    reflected = False
    if (new_position[0] < 0 or new_position[0] >= m):
        change = (change[0] * -1,change[1])
        reflected = True
    if (new_position[1] < 0 or new_position[1] >= n):
        change = (change[0],change[1] * -1)
        reflected = True
    new_dir = change_to_dir(change)
    if (reflected):
        new_dir += 1
    new_dir = normalize_dir(new_dir)
    direction = new_dir

def process_move():
    global pos, direction
    try_reflect()
    change = dir_to_change(direction)
    pos = (pos[0] + change[0], pos[1] + change[1])

summ = 0
summ += matrix[startY][startX]
matrix[startY][startX] = None

def process_cycle():
    steps_left = step
    while (steps_left > 0):
        process_move()
        steps_left -= 1

while True:
    process_cycle()
    val = matrix[pos[1]][pos[0]]
    if (val is None):
        print(summ)
        break
    summ += val
    matrix[pos[1]][pos[0]] = None