#include <iostream>
#include <vector>
#include <algorithm>
#define int long long

using namespace std;

vector<pair<int, int>> go = {{0, 0}, {-1, -1}, {-1, 0}, {-1, 1}, {0, -1}, {0, 1}, {1, -1}, {1, 0}, {1, 1}};

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int n, m;
    cin >> n >> m;
    vector<vector<int>> a(n, vector<int>(m, 0));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cin >> a[i][j];
        }
    }
    int x, y;
    cin >> x >> y;
    --x; --y;
    int v, k;
    cin >> v >> k;
    pair<int, int> d = go[v];
    int ans = 0;
    for (int i = 0; i < n * m; ++i) {
        if (i % k == 0) {
            ans += a[x][y];
            a[x][y] = 0;
        }
        if (x + d.first < 0 || x + d.first >= n) {
            d.first = -d.first;
        }
        if (y + d.second < 0 || y + d.second >= m) {
            d.second = -d.second;
        }
        x += d.first;
        y += d.second;
    }
    cout << ans << "\n";
}
