def material_price(material):
    prices = [50,  # makaroni
              30,  # ovochi
              60,  # sous
              45]  # blini
    return prices[material]


def product_info(product):
    products = [
        # ingredients               time  price
        [[(0, 1), (1, 0.5), (2, 0.2)], 1, 370],
        [[(3, 1), (2, 0.2)], 0.5, 200],
        [[(1, 1.5), (2, 1)], 1, 400]
    ]
    return products[product]
# 3800 +370 +400 -50 -15 -12 -45 -60

def get_product_cost(info):
    res = 0
    for i in info[0]:
        res += material_price(i[0]) * i[1]

    return res


prods = input().split('_')

tot_money_received = 0
tot_money_spent = 0
tot_time = 0


for i in prods:
    p1, p2 = i.split(',')
    info1 = product_info(int(p1)-1)
    info2 = product_info(int(p2)-1)

    tot_time += info1[1]
    tot_time += info2[1]

    if tot_time > 14:
        print(int(tot_money_received - tot_money_spent))
        print('False')
        exit(0)

    tot_money_received += info1[2]
    tot_money_received += info2[2]

    tot_money_spent += get_product_cost(info1)
    tot_money_spent += get_product_cost(info2)

print(int(tot_money_received - tot_money_spent))
print('True')