﻿#include <iostream>
#include <vector>

void solution() {
    int N;
    std::cin >> N;
    std::vector<int> vec(N);
    for (int i = 0; i < N; ++i) {
        std::cin >> vec[i];
    }
    for (int i = 0; i < N; ++i) {
        int a;
        std::cin >> a;
        vec[i] -= a;
    }
    int maxit = 0;
    std::vector<int> dp(N);
    for (int i = 0; i < N; ++i) {
        if (vec[i] < 0) {
            dp[i] = 1;
            maxit = 1;
        }
    }
    if (maxit != 0) {
        for (int i = 0; i < N; ++i) {
            for (int j = i; j > -1; --j) {
                if (vec[i] < vec[j] && vec[j] < 0 && vec[i] < 0) {
                    dp[i] = std::max(dp[i], dp[j] + 1);
                    maxit = std::max(dp[i], maxit);
                }
            }
        }
    }
    std::cout << maxit;
}

int main() {
    std::ios::sync_with_stdio(0);
    std::cin.tie(0);
    std::cout.tie(0);
    solution();
    return 0;
}