#include <iostream>
#include <vector>
#include <set>
#include <algorithm>

using namespace std;
using ll = long long;

const int inf = 1e9 + 7;

signed main() {
	cin.tie(0)->sync_with_stdio(0);
	int n;
	cin >> n;
	vector<int> a(n), b(n), c(n);
	for (auto& u : a) cin >> u;
	for (auto& u : b) cin >> u;
	for (int i = 0; i < n; ++i) {
		c[i] = a[i] - b[i];
	}
	reverse(c.begin(), c.end());
	vector<int> pref;
	for (int i = 0; i < n; ++i) {
		if (c[i] < 0) pref.push_back(c[i]);
	}
	if ((int)pref.size() < 2) {
		cout << (int)pref.size() << "\n";
		return 0;
	}
	vector<int> dp((int)pref.size() + 2, inf);
	dp[1] = pref[0];
	set<pair<int, int>> st;
	for (int i = 1; i < (int)dp.size() - 1; ++i) {
		st.insert({dp[i], i});
	}
	for (int i = 1; i < (int)pref.size(); ++i) {
		if (st.begin() == st.lower_bound({ pref[i], 0 })) continue;
		pair<int, int> x = *(--st.lower_bound({ pref[i], 0 }));
		st.erase({ dp[x.second + 1], x.second + 1 });
		dp[x.second + 1] = pref[i];
		st.insert({ dp[x.second + 1], x.second + 1 });
	}
	int mx = 1;
	for (int i = 1; i <= (int)pref.size(); ++i) {
		if (dp[i] != inf) mx = i;
	}
	cout << mx << "\n";
	return 0;
}