#include <iostream>
#include <vector>
#include <set>
#include <algorithm>

using namespace std;
using ll = long long;

const int inf = 1e9 + 7;

struct X {
	vector<vector<int>> matrix;
	int count, ind;
	X() {}
	X(vector<vector<int>> m, int id) {
		matrix.assign(4, vector<int>(4, 0));
		count = 0;
		ind = id;
		for (int i = 0; i < 4; ++i) {
			for (int j = 0; j < 4; ++j) {
				matrix[i][j] = m[i][j];
				count += m[i][j];
			}
		}
	}
};

vector<X> vec;

signed main() {
	cin.tie(0)->sync_with_stdio(0);
	int n;
	cin >> n;
	for (int it = 0; it < n; ++it) {
		vector<vector<int>> mas(4, vector<int>(4, 0));
		for (int i = 0; i < 4; ++i) {
			for (int j = 0; j < 4; ++j) {
				cin >> mas[i][j];
			}
		}
		vec.emplace_back(mas, it + 1);
	}
	sort(vec.begin(), vec.end(), [](X& a, X& b) {
		if (a.count == b.count) return a.ind < b.ind;
		else return a.count < b.count;
	});
	for (int i = 0; i < n; ++i) {
		cout << vec[i].ind << " \n"[i == n - 1];
	}
	return 0;
}