#include <bits/stdc++.h>

#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("avx2,bmi,bmi2,lzcnt,popcnt")

using namespace std;

#define int long long


struct rect{
    int x1,y1,x2,y2;
    long double per;

    void read(){
        cin>>x1>>y1>>x2>>y2>>per;
        if (x1 > x2){
            swap(x1,x2);
            swap(y1,y2);
        }
    }
};

pair<int,int> get(int angle){
    if (angle == 0 || angle == 360) return make_pair(1,0);
    if (angle == 45) return make_pair(1,1);
    if (angle == 90) return make_pair(0,1);
    if (angle == 135) return make_pair(-1,1);
    if (angle == 180) return make_pair(-1,0);
    if (angle == 225) return make_pair(-1,-1);
    if (angle == 270) return make_pair(0,-1);
    if (angle == 315) return make_pair(1,1);
    return make_pair(1,0);
}

int n;
vector<rect> a;

int on_rect(int x, int y){
    for(int i = 0; i < n; ++i){
        if (x >= min(a[i].x1,a[i].x2) && x <= max(a[i].x1,a[i].x2)){
            if (y >= min(a[i].y1,a[i].y2) && y <= max(a[i].y1,a[i].y2)){
                return i;
            }
        }
    }
    return -1;
}

pair<int,int> rev(pair<int,int> d, int x, int y, int j){
    if (x == a[j].x1 && y == a[j].y1){
        d.first *= -1;
        d.second *= -1;
        return d;
    }
    if (x == a[j].x1 && y == a[j].y2){
        d.first *= -1;
        d.second *= -1;
        return d;
    }
    if (x == a[j].x2 && y == a[j].y1){
        d.first *= -1;
        d.second *= -1;
        return d;
    }
    if (x == a[j].x2 && y == a[j].y2){
        d.first *= -1;
        d.second *= -1;
        return d;
    }

    if (x == a[j].x1 || x == a[j].x2){
        d.first *= -1;
        return d;
    }
    if (y == a[j].y1 || y == a[j].y2){
        d.second *= -1;
        return d;
    }
    return d;
}

signed main() {
    cin.tie(NULL); cout.tie(NULL); ios_base::sync_with_stdio(0);
    int angle;
    long double pw;
    cin>>angle>>pw;
    cin>>n;
    long double spw = pw;
    a.resize(n);
    for(int i = 0; i < n; ++i) a[i].read();
    pair<int,int> d = get(angle);
    int x,y;
    cin>>x>>y;
    int ss = on_rect(0,0);
    if (ss != -1){
        d = rev(d,0,0,ss);
    }
    int sx = 0, sy = 0;
    while(sx != x || sy != y){
        sx += d.first;
        sy += d.second;
        int cur = on_rect(sx,sy);
        //cout<<sx<<' '<<sy<<" | "<<cur<<" | "<<d.first<<' '<<d.second<<endl;
        if (cur != -1){
            pair<int,int> newd = rev(d,sx,sy,cur);
            if (!(newd.first == -d.first && newd.second == -d.second)){
                pw -= (pw * a[cur].per)/100.0f;
            }
            d = newd;
            if (spw * 0.1f > pw){
                cout<<a[cur].x1<<' '<<a[cur].y1<<' '<<a[cur].x2<<' '<<a[cur].y2<<' '<<(int)pw<<'\n';
                return 0;
            }
        }
    }
    cout<<(int)pw<<'\n';
    return 0;
}
