#include <bits/stdc++.h>

#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("avx2,bmi,bmi2,lzcnt,popcnt")

using namespace std;

#define int long long

struct block{
    bitset<3> top, bot;
    int id;

    void read(){
        for(int i = 0; i < 3; ++i){
            for(int j = 0; j < 3; ++j){
                int x;cin>>x;
                if (i == 0) top[j] = x;
                if (i == 2) bot[j]= x;
            }
        }
    }
};

int n;
vector<block> a(n);

bitset<3> full;

void rev(bitset<3> &cur){
    bitset<3> res;
    res[0] = cur[2];
    res[1] = cur[1];
    res[2] = cur[0];
    cur = res;
}

bool ok = false;

void dfs(vector<int> &cur, vector<int> &used){
    if (ok) return;
    if ((int)cur.size() == n){
        /*for(int i = 0; i < n; ++i){
            cout<<cur[i]+1<<' ';
        }
        cout<<'\n';*/
        if (a[cur[0]].top != full) return;
        if (a[cur[n-1]].bot != full) return;
        for(int i = 1; i < n; ++i){
            if ((a[cur[i-1]].bot ^ a[cur[i]].top) != full && (a[cur[i-1]].bot & a[cur[i]].top) != full){
                return;
            }
        }
        for(int i = 0; i < n; ++i){
            cout<<cur[i]+1<<' ';
        }
        cout<<'\n';
        ok = true;
        return;
    }
    for(int i = 0; i < n; ++i){
        if (!used[i]){
            if (cur.empty()){
                if (a[i].top == full){
                    used[i] = 1;
                    cur.push_back(i);
                    dfs(cur,used);
                    used[i] = 0;
                    cur.pop_back();
                }
                if (a[i].bot == full){
                    used[i] = 1;
                    cur.push_back(i);
                    swap(a[i].bot,a[i].top);
                    rev(a[i].bot);
                    rev(a[i].top);
                    dfs(cur,used);
                    swap(a[i].bot,a[i].top);
                    rev(a[i].bot);
                    rev(a[i].top);
                    used[i] = 0;
                    cur.pop_back();
                }
            }
            else{
                if ((a[cur.back()].bot^a[i].top) == full || (a[cur.back()].bot&a[i].top) == full){
                    used[i] = 1;
                    cur.push_back(i);
                    dfs(cur,used);
                    used[i] = 0;
                    cur.pop_back();
                }
                swap(a[i].bot,a[i].top);
                rev(a[i].bot);
                rev(a[i].top);
                if ((a[cur.back()].bot^a[i].top) == full || (a[cur.back()].bot&a[i].top) == full){
                    used[i] = 1;
                    cur.push_back(i);
                    dfs(cur,used);
                    used[i] = 0;
                    cur.pop_back();
                }
                swap(a[i].bot,a[i].top);
                rev(a[i].bot);
                rev(a[i].top);
            }
        }
    }
}

signed main() {
    cin.tie(NULL); cout.tie(NULL); ios_base::sync_with_stdio(0);
    cin>>n;
    a.resize(n);
    full.set();
    for(int i = 0; i < n; ++i){
        a[i].read();
        a[i].id = i;
    }
    vector<int> gg, used(n);
    dfs(gg,used);

    return 0;
}
