#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <iomanip>
#include <cmath>

using namespace std;

#define INFI 2e9
#define INFL 2e18
typedef long long ll;
typedef long double ld;
typedef pair<int, int> point;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    int n;
    cin >> n;
    vector<int> a(n);
    vector<int> b(n);
    for (auto& i : a)
        cin >> i;
    for (auto& i : b)
        cin >> i;
    vector<int> v;
    for (int i = 0; i < n; i++) {
        if (a[i] - b[i] > 0)
            v.push_back(a[i] - b[i]);
    }
    vector<int> dp(v.size(), 1);
    for (int i = 1; i < v.size(); i++) {
        dp[i] = dp[i - 1];
        for (int k = i - 1; k >= 0; k--) {
            if (v[i] > v[k]) {
                dp[i] = max(dp[i], dp[k] + 1);
            }
        }
    }
    if (dp.size() == 0)
        cout << 0;
    else
        cout << dp.back();
    return 0;
}

/*
8
150 250 100 700 700 1000 50 2500
100 200 300 400 500 600 700 20
*/