#include <bits/stdc++.h>

#define int long long
using namespace std;
using ll = long long;
using ull = unsigned long long;
using ld = long double;
//using bl = __int128_t;

int n;
int up = -1, down = -1;
vector<vector<vector<int>>> a;

bool mergem(vector<int> &d) {
    vector<vector<int>> mas(n * 3, vector<int>(3));
    int start = n * 3 - 3;
    for (int i = n * 3 - 3; i < n * 3; i++) {
        for (int j = 0; j < 3; j++) {
            mas[i][j] = a[down][i - start][j];
        }
    }
    start--;
    for (auto i : d) {
        while (start >= 0) {
            bool now = 1;
            for (int j = start; j < start + 3; j++) {
                for (int k = 0; k < 3; k++) {
                    if (a[i][j - start][k] + mas[start][k] != 1) now = 0;
                }
            }
            if (now) {
                for (int j = start; j < start + 3; j++) {
                    for (int k = 0; k < 3; k++) {
                        mas[start][start] = a[i][j - start][k];
                    }
                }
                break;
            }
            start--;
        }
    }
    int prev = 0;
    for (int i = 0; i < n * 3; i++) {
        int summ = mas[i][0] + mas[i][1] + mas[i][2];
        if (summ == 1 || summ == 2) return 0;
        if (summ == 0 && prev == 3) return 0;
        prev = summ;
    }
    return 1;
}

void solve() {
    cin >> n;
    a.resize(n, vector<vector<int>>(3, vector<int>(3)));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < 3; j++) {
            for (int k = 0; k < 3; k++) {
                cin >> a[i][j][k];
            }
            if (a[i][j][0] && a[i][j][1] && a[i][j][2]) {
                if (j == 0) {
                    up = i;
                } else {
                    down = i;
                }
            }
        }
    }
    if (n == 1) {
        cout << 1 << ' ';
        return;
    }
    vector<int> d;
    for (int i = 0; i < n; i++) {
        if (i != up && i != down) d.push_back(i);
    }
    do {
        bool f = mergem(d);
        if (f) break;
    } while (next_permutation(d.begin(), d.end()));
    cout << down + 1 << ' ';
    for (auto i : d) cout << i + 1 << ' ';
    cout << up + 1 << ' ';
}

signed main()
{
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    ios::sync_with_stdio(0);
    cin.tie(0);
    int tt = 1;
//    cin >> tt;
    while (tt--) solve();
}
