//#include <stdafx.h>
#include <iostream>
#include <vector>
#include <string>
#include <limits.h>
#include <set>
#include <map>
using namespace std;

#define int long long 

const int none = -10000000;

map<int, pair<int, int>> d;

void end()
{
	//while(true);
	exit(0);
}

int score = 0;

int checkdir(int dir, int x, int y, int sizex, int sizey)
{
	if (x == 0 && y == 0 && dir == 1)
	{
		cout << score;
		end();
	}
	if (x == sizex - 1 && y == 0 && dir == 7)
	{
		cout << score;
		end();
	}
	if (x == sizex - 1 && y == sizey - 1 && dir == 5)
	{
		cout << score;
		end();
	}
	if (x == 0 && y == sizey - 1 && dir == 3)
	{
		cout << score;
		end();
	}

	auto p = d[dir];
	if (x + p.first >= 0 && x + p.first < sizex && y + p.second >= 0 && y + p.second < sizey)
		return dir;

	if (dir == 0 && x == 0 && y == 0)
		return 5;
	if (dir == 2 && x == 0 && y == sizey - 1)
		return 7;
	if (dir == 4 && x == sizex - 1 && y == sizey - 1)
		return 1;
	if (dir == 6 && x == sizex - 1 && y == 0)
		return 3;

	if ((dir == 0 || dir == 1 || dir == 2) && x == 0)
	{
		switch(dir)
		{
			case 0:
				return 7;
			case 1:
				return 6;
			case 2:
				return 5;
		}
	}
	if ((dir == 6 || dir == 7 || dir == 0) && y == 0)
	{
		switch(dir)
		{
		case 0: return 3;
		case 6: return 5;
		case 7:
			return 4;
		}
	}
	if ((dir == 4 || dir == 5 || dir == 6) && x == sizex -1)
	{
		switch(dir)
		{
		case 4: return 3;
		case 5: return 2;
		case 6:
			return 1;
		}
	}
	if ((dir == 2 || dir == 3 || dir == 4) && y == sizey - 1)
	{
		switch(dir)
		{
		case 2:
			return 1;
		case 3:
			return 0;
		case 4:
			return 7;
		}
	}
	return dir;
}

signed main()
{
	int n, m;
	cin >> n >> m;
	vector<vector<int>> matr(n, vector<int>(m));
	for (auto& i : matr)
		for (auto& j : i)
			cin >> j;
	int x, y, dir;
	cin >> x >> y >> dir;
	x--;
	y--;
	if (dir == 1)
		dir = 0;
	else if (dir == 2)
		dir = 1;
	else if (dir == 3)
		dir = 2;
	else if (dir == 4)
		dir = 7;
	else if (dir == 5)
		dir = 3;
	else if (dir == 6)
		dir = 6;
	else if (dir == 7)
		dir = 5;
	else if (dir == 8)
		dir = 4;
	d[0] = make_pair(-1, -1);
	d[1] = make_pair(-1, 0);
	d[2] = make_pair(-1, 1);
	d[3] = make_pair(0, 1);
	d[4] = make_pair(1, 1);
	d[5] = make_pair(1, 0);
	d[6] = make_pair(1, -1);
	d[7] = make_pair(0, -1);

	while(true)
	{
		if (matr[x][y] == none)
		{
			cout << score;
			end();
		}
		score += matr[x][y];
		matr[x][y] = none;
		for (int i = 0; i < 5; i++)
			dir = checkdir(dir, x, y, n, m);
		x += d[dir].first;
		y += d[dir].second;
	}

	//while(true);
}

/*
3
1 0 0
1 1 0
0 1 1
1 1 1
0 1 1
0 0 1
1 0 0
1 1 1
1 1 1
*/