//#include <stdafx.h>
#include <iostream>
#include <vector>
#include <string>
#include <limits.h>
#include <set>

using namespace std;

#define int long long 

const int none = -10000000;

void end()
{
	//while(true);
	exit(0);
}

set<int> starts, endss;

void dfs(int v, vector<vector<int>>& matr, vector<int>& path, vector<int>& used)
{
	if (used[v])
		return;
	used[v] = true;
	path.push_back(v);

	if (path.size() == matr.size())
	{
		if (starts.find(path[0]) != starts.end() && endss.find(path.back()) != endss.end()) 
		{
			for (auto& i : path)
				cout << i + 1 << ' ';
			end();
		}
	}

	for (auto& i : matr[v])
		dfs(i, matr, path, used);

	path.pop_back();
	used[v] = false;
}

signed main()
{

	int size;
	cin >> size;
	vector<vector<vector<int>>> v(size);
	for (auto& i : v)
	{
		i.resize(3, vector<int>(3, 0));
		for (auto& j : i)
			for (auto& k : j)
				cin >> k;
	}

	vector<pair<vector<int>, vector<int>>> c(size);
	for (int i = 0; i < size; i++)
	{
		c[i].first.resize(3);
		c[i].second.resize(3);
	}

	for (int cube = 0; cube < size; cube++)
	{
		for (int i = 0; i < 3; i++)
		{
			for (int j = 0; j < 3; j++)
			{
				c[cube].first[i] = j;
				if (v[cube][j][i] == 1)
					break;
			}
		}
		for (int i = 0; i < 3; i++)
		{
			for (int j = 0; j < 3; j++)
			{
				c[cube].second[i] = j;
				if (v[cube][2 - j][i] == 1)
					break;
			}
		}
	}

	vector<vector<int>> matr(size);

	for (int i = 0; i < size; i++)
	{
		for (int j = 0; j < size; j++)
		{
			if (i == j) 
				continue;
			vector<int> d(3);
			for (int s = 0; s < 3; s++)
				d[s] = c[i].first[s] + c[j].second[s];
			if (d[0] == d[1] && d[0] == d[2])
				matr[i].push_back(j);
		}
	}

	for (int i = 0; i < size; i++)
	{
		if (c[i].first[0] == c[i].first[1] && c[i].first[0] == c[i].first[2])
			endss.insert(i);
		if (c[i].second[0] == c[i].second[1] && c[i].second[0] == c[i].second[2])
			starts.insert(i);
	}

	vector<int> p;
	vector<int> used(size, 0);

	for (auto& i : starts)
		dfs(i, matr, p, used);


	//while(true);
}

/*
3
1 0 0
1 1 0
0 1 1
1 1 1
0 1 1
0 0 1
1 0 0
1 1 1
1 1 1
*/