#include <iostream>
#include <algorithm>
#include <vector>
#include <fstream>

using namespace std;

typedef long long ll;

void my_file(){
    freopen("/Users/maratkhisamutdinov/Desktop/OLIMP/input.txt", "r", stdin);
    freopen("/Users/maratkhisamutdinov/Desktop/OLIMP/output.txt", "w", stdout);
}

struct SegTree{
    int n;
    vector<int> t;

    SegTree(){
        n = 5e5;
        t.resize(4 * n + 4, 0);
    }

    void upd(int pos, int val, int v, int l, int r){
        if(l == r - 1){
            t[v] = val;
            return;
        }
        int m = (l + r) / 2;
        if(pos < m){
            upd(pos, val,  2 * v + 1, l, m);
        } else{
            upd(pos, val,  2 * v + 2, m, r);
        }
        t[v] = max(t[2 * v + 1], t[2 * v + 2]);
    }

    int get(int ql, int qr, int v, int l, int r){
        if(qr <= l || r <= ql) return 0;
        if(ql <= l && r <= qr) return t[v];
        int m = (l + r) / 2;
        return max(get(ql, qr, 2 * v + 1, l, m), get(ql, qr, 2 * v + 2, m, r));
    }
};

void solve(){
    int n; cin >> n;
    vector<int> a(n), b(n);
    for(int i = 0; i < n; i++) cin >> a[i];
    for(int i = 0; i < n; i++) cin >> b[i];
    vector<int> v;
    for(int i = 0; i < n; i++){
        if(a[i] - b[i] > 0) v.push_back(a[i] - b[i]);
    }
    SegTree t;
    int ans = 0;
    for(int i: v){
        int q = t.get(0, i, 0, 0, 5e5) + 1;
        ans = max(ans, q);
        t.upd(i, q,  0, 0, 5e5);
    }
    cout << ans;
}

int main(){
    ios_base::sync_with_stdio(false); cin.tie(nullptr);
//    my_file();
    solve();
}