#include <iostream>
#include <algorithm>
#include <vector>
#include <fstream>

using namespace std;

typedef long long ll;

void my_file(){
    freopen("/Users/maratkhisamutdinov/Desktop/OLIMP/input.txt", "r", stdin);
    freopen("/Users/maratkhisamutdinov/Desktop/OLIMP/output.txt", "w", stdout);
}

void solve(){
    int n, m, x, y, t, q; cin >> n >> m;
    vector<vector<int>> v(n, vector<int>(m));
    vector<vector<bool>> used(n, vector<bool>(m, false));
    for(int i = 0; i < n; i++){
        for(int j = 0; j < m; j++){
            cin >> v[i][j];
        }
    }
    cin >> x >> y;
    cin >> t >> q;
    x--; y--;
    vector<pair<int, int>> d;
    d.emplace_back(0, 0);
    d.emplace_back(-1, -1);
    d.emplace_back(-1, 0);
    d.emplace_back(-1, 1);
    d.emplace_back(0, -1);
    d.emplace_back(0, 1);
    d.emplace_back(1, -1);
    d.emplace_back(1, 0);
    d.emplace_back(1, 1);

    pair<int, int> dir;
    dir = d[t];
    ll sum = 0;
    int dist = q;
    while(dist != q || !used[x][y]){
        if(dist == q){
            if(used[x][y]) break;
            dist = 0;
            sum += v[x][y];
            used[x][y] = true;
        }
            if (dir == d[1] && (x == 0 || y == 0)) {
                if (x == 0 && y == 0) dir = d[7];
                else if (x == 0) dir = d[5];
                else dir = d[4];
            } else if (dir == d[2] && x == 0){
                dir = d[6];
            }
            else if (dir == d[3] && (x == 0 || y == m - 1)) {
                if (x == 0 && y == m - 1) dir = d[4];
                else if (x == 0) dir = d[7];
                else dir = d[2];
            }
            else if (dir == d[4] && y == 0) {
                dir = d[8];
            }
            else if (dir == d[5] && y == n - 1) {
                dir = d[1];
            }
            else if (dir == d[6] && (x == n - 1 || y == 0)) {
                if (x == n - 1 && y == 0) dir = d[5];
                else if (x == n - 1) dir = d[2];
                else dir = d[7];
            }

            else if (dir == d[7] && x == n -1 ) {
                dir = d[3];
            }
            else if (dir == d[8] && (x == n - 1 || y == m - 1)) {
                if (x == n - 1 && y == m - 1) dir = d[2];
                else if (x == n - 1) dir = d[5];
                else dir = d[4];
            }
            x += dir.first;
            y += dir.second;
        dist++;
    }
    cout << sum;
}

int main(){
    ios_base::sync_with_stdio(false); cin.tie(nullptr);
//    my_file();
    solve();
}