#include <bits/stdc++.h>

using namespace std;

#define all(x) x.begin(), x.end()
#define x first
#define y second
#define log_2(x) (63-__builtin_clzll(x))
#define set_sum(x) (__builtin_popcountll(x))
#define mp(x, y) make_pair(x, y)

typedef long long int ll;
typedef long long unsigned int ull;
typedef long double ld;
#define int ll
typedef const int ci;
typedef uint32_t uint;
typedef pair<int, int> pii;
typedef pair<ld, ld> pld;
typedef vector<int> vi;
typedef vector<vector<int>> vvi;

const int INF = INT64_MAX;
const int MaxN = (1 << 20) + 5;


int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int n, m;
    cin >> n >> m;
    vvi matrix(n, vi(m));
    vector<vector<bool>> visited(n, vector<bool>(m, false));
    for (int i = 0; i < n; ++i)
        for (int j = 0; j < m; ++j)
            cin >> matrix[i][j];

    pii pos;
    cin >> pos.x >> pos.y;
    --pos.x, --pos.y;

    int dir, skip;
    cin >> dir >> skip;
    --dir;

    int ans = 0;
    vector<pii> moves{
            {-1, -1},
            {-1, 0},
            {-1, 1},
            {0,  -1},
            {0,  1},
            {1,  -1},
            {1,  0},
            {1,  1}
    };
    vi sw1{3, 5, 6, 7, 0, 1, 2, 4};
    vi sw2{6, 4, 3, 1, 6, 1, 3, 1};
    vi sw3{4, 5, 1, 7, 0, 6, 2, 3};

    int skipped = skip;
    while (skipped < skip || (skipped == skip && !visited[pos.x][pos.y])) {
        if (skipped == skip) {
            visited[pos.x][pos.y] = true;
            ans += matrix[pos.x][pos.y];
            skipped = 0;
        }
        pos.x += moves[dir].x;
        pos.y += moves[dir].y;
        if (pos.x == -1 || pos.x == n || pos.y == -1 || pos.y == m) {
            pos.x -= moves[dir].x;
            pos.y -= moves[dir].y;

            if (dir == 1 || dir == 3 || dir == 4 || dir == 6) {
                if (dir == 1) {
                    if (pos.x == 0 && pos.y == 0) dir = sw2[dir];
                    else dir = sw1[dir];
                } else if (dir == 3) {
                    if (pos.x == n - 1 && pos.y == 0) dir = sw2[dir];
                    else dir = sw1[dir];
                } else if (dir == 4) {
                    if (pos.x == 0 && pos.y == m - 1) dir = sw2[dir];
                    else dir = sw1[dir];
                } else if (dir == 6) {
                    if (pos.x == n - 1 && pos.y == m - 1) dir = sw2[dir];
                    else dir = sw1[dir];
                }
            } else if (dir == 0 || dir == 5) {
                if (dir == 0 && pos.y == 0 && pos.x == 0) dir = sw2[dir];
                else if (dir == 5 && pos.y == 0 && pos.x == n - 1) dir = sw2[dir];
                else {
                    if (pos.y == 0) dir = sw3[dir];
                    else dir = sw1[dir];
                }
            } else {
                if (dir == 2 && pos.y == m - 1 && pos.x == 0) dir = sw2[dir];
                else if (dir == 7 && pos.y == m - 1 && pos.x == n - 1)dir = sw2[dir];
                else {
                    if (pos.y == m - 1) dir = sw3[dir];
                    else dir = sw1[dir];
                }
            }
            pos.x += moves[dir].x;
            pos.y += moves[dir].y;
        }
        ++skipped;
    }
    cout << ans;
    return 0;
}
