#include <bits/stdc++.h>

using namespace std;

#define all(x) x.begin(), x.end()
#define x first
#define y second
#define log_2(x) (63-__builtin_clzll(x))
#define set_sum(x) (__builtin_popcountll(x))
#define mp(x, y) make_pair(x, y)

typedef long long int ll;
typedef long long unsigned int ull;
typedef long double ld;
#define int ll
typedef const int ci;
typedef uint32_t uint;
typedef pair<int, int> pii;
typedef pair<ld, ld> pld;
typedef vector<int> vi;
typedef vector<vector<int>> vvi;

const int INF = INT64_MAX;
const int MaxN = (1 << 20) + 5;

int get_up(vvi &a) {
    for (int i = 0; i < 4; ++i) {
        int sum = 0;
        for (int j = 0; j < 4; ++j) sum += a[i][j];
        if (sum == 4) return i;
    }
}

bool set_mask(vvi &a, vvi &b, int &up) {
    for (int i = up - 1, j = 3; i >= 0; --i, --j)
        for (int k = 0; k < 4; ++k)
            if (a[i][k] == b[j][k]) return false;

    for (int i = up - 1, j = 3; i >= 0; --i, --j)
        for (int k = 0; k < 4; ++k) b[j][k] = 1;
    return true;
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int n;
    cin >> n;
    vector<vvi> mas(n, vvi(4, vi(4)));
    for (int i = 0; i < n; ++i)
        for (int j = 0; j < 4; ++j)
            for (int k = 0; k < 4; ++k)
                cin >> mas[i][j][k];

    vector<bool> used(n);
    vi ans;
    int cur = 0, last = 0;
    vi cst = {1, 1, 1, 1};
    for (int i = 0; i < n; ++i)
        if (mas[i][3] == cst) {
            cur = i;
        } else if (mas[i][0] == cst) {
            last = i;
        }

    used[cur] = true, used[last] = true;
    ans.emplace_back(cur);
    bool move = true;
    while (move) {
        move = false;
        int up = get_up(mas[cur]);
        for (int i = 0; i < n; ++i) {
            if (!used[i] && set_mask(mas[cur], mas[i], up)) {
                used[i] = move = true;
                cur = i, ans.emplace_back(i);
            }
        }
    }

    ans.emplace_back(last);
    for (auto &i: ans) cout << i + 1 << ' ';
    return 0;
}