from dataclasses import dataclass

@dataclass
class Rs:
    t: int = 0
    zp: int = 0
    mc: int = 0
    pl: int = 0
    fd: int = 0

@dataclass
class Bld:
    re_build: int
    re_req: int = -1
    re_prod: int = -1


def main():
    # запчасти, микросхемы, пластик, еда
    Rbld = [Rs(6, 5, 5, 5), Rs(4, pl=10, zp=5),
           Rs(10, mc=5, zp=10, pl=10), Rs(8, mc=5, zp=10, pl=8)]
    Rprd = [Rs(2, zp=2, pl=1), Rs(6, fd=8), Rs(10, mc=6), Rs(7, pl=7)]
    Rreq = [Rs(5, zp=1), Rs(10, pl=2), Rs(20, zp=2), Rs(12, zp=1, mc=1)]


    # every 10
    x = int(input())
    y = int(input())
    pln = [[int(input()) for _ in range(5)] for __ in range(4)]
    blds = [[], [], [], []]
    res = Rs(0, 40, 40, 40, 40)

    for i in range(1, 101):
        res.t = i
        if i % 10 == 0:
            res.zp += x; res.pl += x; res.mc += x; res.fd += x
        res.zp -= y; res.pl -= y; res.mc -= y; res.fd -= y

        for j in range(4):
            for p in pln[j]:
                if p == i:
                    blds[j].append(Bld(Rbld[j].t))
                    res.pl -= Rbld[j].pl; res.mc -= Rbld[j].mc
                    res.fd -= Rbld[j].fd; res.zp -= Rbld[j].zp

        for j in range(4):
            for bl in blds[j]:
                bl.re_build -= 1; bl.re_req -= 1; bl.re_prod -= 1
                if bl.re_build == 0:
                    bl.re_req = Rreq[j].t
                    bl.re_prod = Rprd[j].t
                    continue

                if bl.re_prod == 0:
                    bl.re_prod = Rprd[j].t
                    res.pl += Rprd[j].pl; res.mc += Rprd[j].mc
                    res.fd += Rprd[j].fd; res.zp += Rprd[j].zp

                if bl.re_req == 0:
                    bl.re_req = Rreq[j].t
                    res.pl -= Rreq[j].pl; res.mc -= Rreq[j].mc
                    res.fd -= Rreq[j].fd; res.zp -= Rreq[j].zp

        if min(res.pl, res.fd, res.mc, res.zp) <= 0:
            break

    print(res.t, res.zp, res.mc, res.pl, res.fd, sep='\n')


if __name__ == '__main__':
    main()
