class Building:
    def __init__(self, a, p, c, f, a1, p1, c1, f1, b_t, i, c_i, t):
        self.components_prod = a
        self.plastic_prod = p
        self.chips_prod = c
        self.food_prod = f
        self.components_cons = a1
        self.plastic_cons = p1
        self.chips_cons = c1
        self.food_cons = f1
        self.build_time = b_t - 1
        self.production_interval = i
        self.cons_interval = c_i
        self.start = -1
        self.type = t


plastic, chips, food, components = 40, 40, 40, 40
build_plan = [[0, 0, 0, 0, 0] for i in range(4)]
x = int(input())
y = int(input())
for i in range(4):
    for j in range(5):
        build_plan[i][j] = int(input())
buildings = []
for i in range(1, 101):
    plastic -= y
    chips -= y
    food -= y
    components -= y
    if i % 10 == 0:
        plastic += x
        chips += x
        components += x
        food += x
    for j in range(len(buildings)):
        if buildings[j].start != -1:
            if (i - buildings[j].start) % buildings[j].production_interval == 0 and (i - buildings[j].start) > 0:
                plastic, chips, food, components = plastic + buildings[j].plastic_prod, chips + buildings[
                    j].chips_prod, food + buildings[j].food_prod, components + buildings[j].components_prod
            if (i - buildings[j].start) % buildings[j].cons_interval == 0 and (i - buildings[j].start) > 0:
                plastic, chips, food, components = plastic - buildings[j].plastic_cons, chips - buildings[
                    j].chips_cons, food - buildings[j].food_cons, components - buildings[j].components_cons
        if buildings[j].build_time > 0:
            buildings[j].build_time -= 1
            if buildings[j].build_time == 0:
                buildings[j].start = i
                buildings[j].build_time = -1

    if plastic <= 0 or food <= 0 or chips <= 0 or components <= 0:
        break

    for j in range(4):
        for k in range(5):
            if build_plan[j][k] == i:
                if j == 0:
                    if components >= 5 and chips >= 5 and plastic >= 5:
                        components -= 5
                        chips -= 5
                        plastic -= 5
                        buildings.append(Building(2, 1, 0, 0, 1, 0, 0, 0, 6, 2, 5, 0)) # запчасти пластик микросхемы еда строительство производство потребление тип
                if j == 1:
                    if components >= 5 and plastic >= 10:
                        components -= 5
                        plastic -= 10
                        buildings.append(Building(0, 0, 0, 8, 0, 2, 0, 0, 4, 6, 10,
                                                  1))  # запчасти пластик микросхемы еда строительство производство потребление тип
                if j == 2:
                    if components >= 10 and chips >= 5 and plastic >= 10:
                        components -= 10
                        chips -= 5
                        plastic -= 10
                        buildings.append(Building(0, 0, 6, 0, 2, 0, 0, 0, 10, 10, 20,
                                                  2))  # запчасти пластик микросхемы еда строительство производство потребление тип
                if j == 3:
                    if components >= 10 and chips >= 5 and plastic >= 8:
                        components -= 10
                        chips -= 5
                        plastic -= 8
                        buildings.append(Building(0, 7, 0, 0, 1, 0, 1, 0, 8, 7, 12,
                                                  3))  # запчасти пластик микросхемы еда строительство производство потребление тип
print(min(i, 100), max(0, components), max(0, chips), max(0, plastic), max(0, food), sep="\n")
