﻿#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <stack>
#include <set>
#include <map>

using namespace std;

#define ll long long
#define pll pair<ll,ll>

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<int>> a(n, vector<int>(m));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++)
            cin >> a[i][j];
    }
    map<pair<int, int>, bool> used;
    bool pr = 0;
    int x, y;
    cin >> y >> x;
    x--, y--;
    int t;
    cin >> t;
    pll to;
    // x, y
    if (t == 1) {
        to = { -1, -1 };
    }
    if (t == 2) {
        to = { 0, -1 };
    }
    if (t == 3) {
        to = { 1, -1 };
    }
    if (t == 4) {
        to = { -1, 0 };
    }
    if (t == 5) {
        to = { 1, 0 };
    }
    if (t == 6) {
        to = { -1, 1 };
    }
    if (t == 7) {
        to = { 0, 1 };
    }
    if (t == 8) {
        to = { 1, 1 };
    }
    if (n == 1) {
        int ans = 0;
        for (int i = 0; i < m; i++)
            ans += a[0][i];
        cout << ans << "\n";
        return;
    }

    if (m == 1) {
        int ans = 0;
        for (int i = 0; i < m; i++)
            ans += a[i][0];
        cout << ans << "\n";
        return;
    }
    ll ans = 0;
    ans += a[y][x];
    used[{x, y}] = 1;
    while (true) {
        if (x + to.first < 0 || x + to.first >= m)
            to.first *= -1;
        if (y + to.second < 0 || y + to.second >= n)
            to.second *= -1;
        x += to.first, y += to.second;
        if (used[{x, y}] && pr == 1) {
            break;
        }
        if (!used[{x, y}]) {
            ans += a[y][x];
            pr = 0;
            used[{x, y}] = 1;
          // cout << used[{x, y}];
        }
        else
            pr = 1;

        
    }
    cout << ans << "\n";
}

/*
1 5
1 2 3 4 5
1 1
3
*/

int main()
{
    int t = 1;
    // cin >> t;
    while (t--)
        solve();
}
