class Stock:
    ep = 30
    ti = 30
    bn = 30
    fd = 30
    def is_alive(self):
        return self.ep > 0 and self.ti > 0 and self.bn > 0 and self.fd > 0

STOCK = Stock()

class Build:
    def __init__(self, time_to_build, period_prod, cost_ti=0,
                 cost_ep=0, cost_bn=0, prod_ti=0, prod_ep=0,
                 prod_bn=0, prod_fd=0, period_waste=0,
                 waste_ti=0, waste_bn=0, waste_ep=0):
        self.time_to_build = time_to_build
        self.cost_ti = cost_ti
        self.cost_ep = cost_ep
        self.cost_bn = cost_bn
        self.prod_ti = prod_ti
        self.prod_ep = prod_ep
        self.prod_bn = prod_bn
        self.prod_fd =  prod_fd
        self.period_prod = period_prod
        self.cooldown_prod = time_to_build + 1 + period_prod
        self.cooldown_waste = time_to_build + 1 + period_waste
        self.period_waste = period_waste
        self.waste_ti=waste_ti
        self.waste_bn=waste_bn
        self.waste_ep=waste_ep
        
    def tick(self):
        if not self.cooldown_waste:
            self.cooldown_waste = self.period_waste
            STOCK.ti -= self.waste_ti
            STOCK.bn -= self.waste_bn
            STOCK.ep -= self.waste_ep
        else:
            self.cooldown_waste -= 1
        
        if not self.cooldown_prod:
            self.cooldown_prod = self.period_prod
            STOCK.ti += self.prod_ti
            STOCK.ep += self.prod_ep
            STOCK.bn += self.prod_bn
            STOCK.fd += self.prod_fd
        else:
            self.cooldown_prod -= 1
        
        



X = int(input())
Y = int(input())

plan_1 = []
plan_2 = []
plan_3 = []
plan_4 = []

for _ in range(5):
    p = int(input())
    if p:
        plan_1.append(p)
for _ in range(5):
    p = int(input())
    if p:
        plan_2.append(p)
for _ in range(5):
    p = int(input())
    if p:
        plan_3.append(p)
for _ in range(5):
    p = int(input())
    if p:
        plan_4.append(p)

builds = []

month = 0
while STOCK.is_alive():
    #month += 1
    if month in plan_1:
        build = Build(time_to_build=5,
                      cost_ti=8, cost_ep=3, cost_bn=10,
                      period_prod=2, prod_bn=5, prod_ti=3,
                      period_waste=5, waste_ti=3)
        if STOCK.ti >= build.cost_ti and STOCK.ep >= build.cost_ep and STOCK.bn >= build.cost_bn:
            STOCK.ep -= build.cost_ep
            STOCK.ti -= build.cost_ti
            STOCK.bn -= build.cost_bn
            builds.append(build)
    if month in plan_2:
        build = Build(time_to_build=5,
                     cost_bn=8, cost_ti=5,
                     period_prod=5, prod_fd=7,
                     period_waste=10, waste_bn=2)
        if STOCK.ti >= build.cost_ti and STOCK.ep >= build.cost_ep and STOCK.bn >= build.cost_bn:
            STOCK.ep -= build.cost_ep
            STOCK.ti -= build.cost_ti
            STOCK.bn -= build.cost_bn
            builds.append(build)
    if month in plan_3:
        build = Build(time_to_build=10,
                     cost_ep=6, cost_ti=10, cost_bn=10,
                     period_prod=10, prod_ep=6,
                     period_waste=18, waste_ti=2)
        if STOCK.ti >= build.cost_ti and STOCK.ep >= build.cost_ep and STOCK.bn >= build.cost_bn:
            STOCK.ep -= build.cost_ep
            STOCK.ti -= build.cost_ti
            STOCK.bn -= build.cost_bn
            builds.append(build)
    if month in plan_4:
        build = Build(time_to_build=8,
                     cost_ep=4,cost_ti=8, cost_bn=8,
                     period_prod=8,  prod_bn=8,
                     period_waste=12, waste_ti=1, waste_ep=1)
        if STOCK.ti >= build.cost_ti and STOCK.ep >= build.cost_ep and STOCK.bn >= build.cost_bn:
            STOCK.ep -= build.cost_ep
            STOCK.ti -= build.cost_ti
            STOCK.bn -= build.cost_bn
            builds.append(build)

    if month % 10 == 0 and month != 0:
        STOCK.ep += X
        STOCK.ti += X
        STOCK.bn += X
        STOCK.fd += X

    for build in builds:
        build.tick()

    STOCK.ep -= Y
    STOCK.ti -= Y
    STOCK.bn -= Y
    STOCK.fd -= Y
    month += 1

    

print(month)
print(STOCK.ti)
print(STOCK.ep)
print(STOCK.bn)
print(STOCK.fd)
        
        
    
