#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
const ll infll = 1e9;

pii getnp(int np) {
    if (np == 0) return {1, 0};
    else if (np == 45) return {1, 1};
    else if (np == 90) return {0, 1};
    else if (np == 135) return {-1, 1};
    else if (np == 180) return {-1, 0};
    else if (np == 225) return {-1, -1};
    else if (np == 270) return {0, -1};
    else if (np == 315) return {1, -1};
    else {
        throw 3;
    }
}

struct bull {
    ll x1, y1, x2, y2;
    ld in;
    bull() {}
};

pii getroute(ll x, ll y, bull& b) {
    if (x == b.x1 && y == b.y2) {
        return {-1, 1};
    } else if (x == b.x2 && y == b.y2) {
        return {1, 1};
    } else if (x == b.x2 && y == b.y2) {
        return {1, -1};
    } else if (x == b.x1 && y == b.y1) {
        return {-1, -1};
    } else {
        throw 3;
    }
}

void solve() {
    ll np; ld val; cin >> np >> val;
    ll dx = getnp(np).first, dy = getnp(np).second;
    ld valst = val;

    ll n; cin >> n;
    vector<bull> v(n);
    for (int i = 0; i < n; ++i) {
        ll x1, y1, x2, y2; cin >> x1 >> y1 >> x2 >> y2 >> v[i].in;
        v[i].x1 = min(x1, x2), v[i].x2 = max(x1, x2);
        v[i].y1 = min(y1, y2), v[i].y2 = max(y1, y2);
    }

    ll x = 0, y = 0;
    ll tox, toy; cin >> tox >> toy;

    while (1) {
        if (tox == x && toy == y) {
            cout << (ll)(val) << endl;
            return;
        }
//        cout << x << " " << y << endl;

        for (int i = 0; i < n; ++i) {
            int p1 = 0, p2 = 0;
            if ((x == v[i].x1 || x == v[i].x2) && (v[i].y1 <= y && y <= v[i].y2)) {
                p1 = 1;
            }
            if ((y == v[i].y1 || y == v[i].y2) && (v[i].x1 <= x && x <= v[i].x2)) {
                p2 = 1;
            }

            if (p1 == 1 && p2 == 1) {
                dx = getroute(x, y, v[i]).first, dy = getroute(x, y, v[i]).second;
            } else if (p1 == 1) {
                dx *= -1;
            } else if (p2 == 1) {
                dy *= -1;
            }

            if (p1 || p2) {
                val *= (100 - v[i].in) / 100;
                if (val < valst * 0.1) {
                    cout << v[i].x1 << " " << v[i].y2 << " " << v[i].x2 << " " << v[i].y1 << " " << (ll)(val) << endl;
                    return;
                }
            }
        }

        x += dx, y += dy;
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    // freopen("input.txt", "rt", stdin);

    solve();

    return 0;
}
