//#define _GLIBCXX_DEBUG
//#include <bits\stdc++.h>
#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>

using namespace std;

using ll = long long;
const ll inf = 1e18, inf2 = 2e18;
ll n;

vector <vector <string> > cubes;

void rec(int ind, vector <vector <int> > cnt, vector <int> used) {
//    for (auto e : used) cout << e << " ";
//    cout << endl;
    if (ind >= n) {
        vector <ll> ans(n);
        for (int i = 0; i < n; i++) {
            ans[used[i]] = i;
        }
        bool m = true;
        for (int i = 1; i < n; i++) {
            ll last = ans[i - 1], now = ans[i];
            vector <int> place(3, 0), to(3, 0);
            for (int y =0; y < 3; y++) {
                for (int x = 0; x < 3; x++) {
                    if (cubes[last][x][y] == '0') {
                        place[y]++;
                    } else {
                        break;
                    }
                }
            }
            //

            for (int y =0; y < 3; y++) {
                for (int x = 2; x >= 0; x--) {
                    if (cubes[now][x][y] == '0') {
                        to[y]++;
                    } else {
                        break;
                    }
                }
            }
            /*for (auto e : to) {
                cout << e << " ";
            }
            cout << endl << ans[i] << endl;*/
            int min_sum = 50;
            for (int h = 0; h < 3; h++) {
                min_sum = min(min_sum, place[h] + to[h]);
            }
            for (int h = 0; h < 3; h++) {
                if (place[h] + to[h] - min_sum > 0) {
                    m = false;
//                    cout << place[h] << " " << to[h] << " " << min_sum << endl;
                }
            }
        }
        if (!m) return;
        for (auto e : ans) cout << e + 1<< " ";
        return;
    }
    for (int i = 0; i < n; i++) {
        if (used[i] != -1) {
            continue;
        }
        bool take = true;
        if (ind == 0 && (cubes[i][2][0] == '0' || cubes[i][2][1] == '0' || cubes[i][2][2] == '0')){
            take = false;
        }
        if (ind == n - 1 && (cubes[i][0][0] == '0' || cubes[i][0][1] == '0' || cubes[i][0][2] == '0')){
            take = false;
        }
        used[i] = ind;
        if (take) {
            rec(ind + 1, cnt, used);
        }
        used[i] = -1;
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cin >> n;
    cubes.resize(n, vector <string> (3));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < 3; j++) {
            string s = "";
            for (int h = 0; h < 3; h++) {
                char x;
                cin >> x;
                s.push_back(x);
            }
            cubes[i][j] = s;
        }
    }
    vector <vector <int> > c(3, vector <int>(3, 0));
    vector <int> u(n, -1);
    rec(0, c, u);
    return 0;
}
