def get_pos(is_white, s):
    s = s.lower()

    if is_white:
        i = s.find("w")
    else:
        i = s.find("b")

    return (i // 8 + 1, i % 8 + 1)


c = input()

s = str()
for i in range(8):
    s += input()

s = s.replace(" ", "")

black_pos = get_pos(False, s)
black_is_dama = (s.find("B") != -1)

white_pos = get_pos(True, s)
white_is_dama = (s.find("W") != -1)

win_pos = list()
curr_pos = list()
is_winning = False
if c == "w":
    curr_pos = white_pos
    go_until = (9 if white_is_dama else 2)
    for i in range(1, go_until):
        if (black_pos[0] == (white_pos[0] - i)) and (black_pos[1] == (white_pos[1] - i)):
            is_winning = True
            win_pos = [black_pos[0] - 1, black_pos[1] - 1]
            break

        if (black_pos[0] == (white_pos[0] - i)) and (black_pos[1] == (white_pos[1] + i)):
            is_winning = True
            win_pos = [black_pos[0] - 1, black_pos[1] + 1]
            break
else:
    curr_pos = black_pos
    go_until = (9 if black_is_dama else 2)
    for i in range(1, go_until):
        if (white_pos[0] == (black_pos[0] + i)) and (white_pos[1] == (black_pos[1] - i)):
            is_winning = True
            win_pos = [white_pos[0] + 1, white_pos[1] - 1]
            break

        if (white_pos[0] == (black_pos[0] + i)) and (white_pos[1] == (black_pos[1] + i)):
            is_winning = True
            win_pos = [white_pos[0] + 1, white_pos[1] + 1]
            break

if is_winning:
    if (win_pos[0] > 0) and (win_pos[0] < 9) and (win_pos[1] > 0) and (win_pos[1] < 9):
        print(*curr_pos)
    else:
        print(0)
else:
    print(0)
