n, m = map(int, input().split())

matrix = list()
holes = list()
for i in range(n):
    matrix.append(list(map(int, input().split())))
    holes.append([False] * m)

start_pos = tuple(map(int, input().split()))
direction, step = map(int, input().split())

directions = {
    1: (-1, -1),
    2: (0, -1),
    3: (1, -1),
    4: (-1, 0),
    5: (1, 0),
    6: (-1, 1),
    7: (0, 1),
    8: (1, 1),
}

direction_to = {
    (-1, -1): 0,
    (0, -1): 1,
    (1, -1): 2,
    (-1, 0): 7,
    (1, 0): 3,
    (-1, 1): 6,
    (0, 1): 5,
    (1, 1): 4,
}

transpon_to = [1, 2, 3, 5, 8, 7, 6, 4]

score = 0
counter = 0

y = (start_pos[0] - 1)
x = (start_pos[1] - 1)
velocity = list(directions[direction])
while True:
    if counter == 0:
        if holes[y][x]:
            break

        score += matrix[y][x]
        holes[y][x] = True


    x = max(0, min(m - 1, x + velocity[0]))
    y = max(0, min(n - 1, y + velocity[1]))

    new_velocity = velocity.copy()
    if ((x == 0) or (x == (m - 1))) and (direction not in [2, 7]):
        new_velocity[0] = -new_velocity[0]

    if ((y == 0) or (y == (n - 1))) and (direction not in [4, 5]):
        new_velocity[1] = -new_velocity[1]

    if velocity != new_velocity:
        direction = transpon_to[(direction_to[tuple(new_velocity)] + 1) % 8]
        velocity = list(directions[direction])

    counter = ((counter + 1) % step)

print(score)