n = int(input())
blocks = [(0, 0)] * n
for i in range(n):
    s, _, e = ([i == '1' for i in input().split()] for _ in range(3))
    blocks[i] = s, e

can_be_used = {i for i in range(n)}
way = []


def solve(prev_e, depth=0):
    if len(way) == n-1:
        for i in way: print(i+1, end=' ')
        for i in can_be_used: print(i+1)
        return True

    for block in can_be_used:
        cur_s, cur_e = blocks[block]
        if cur_s == [True] * 3 or cur_e == [True] * 3:
            continue

        if prev_e == [not j for j in cur_s]:
            can_be_used.remove(block), way.append(block)
            if solve(cur_e, depth+1): return True
            can_be_used.add(block), way.pop()

        if prev_e == [not j for j in cur_e[::-1]]:
            can_be_used.remove(block), way.append(block)
            if solve(cur_s[::-1], depth+1): return True
            can_be_used.add(block), way.pop()
    return False


for i in range(n):
    s, e = blocks[i]
    if s == [True] * 3:
        way.append(i), can_be_used.remove(i)
        solve(e)
        break
    if e == [True] * 3:
        way.append(i), can_be_used.remove(i)
        solve(s[::-1])
        break
