#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using vll = vector<ll>;
struct edge{
	ll x, y, dx, dy, cnt;
};
ll n, m;
bool corner(ll i, ll j){
	return (i == 0 && j == 0) || (i == 0 && j == m-1)
	|| (i == n-1 && j == 0) || (i == n-1 && j == m-1);
}
bool wall(ll i, ll j){
	return (i == 0) || (j == 0) || (i == n-1) || (j == m-1);
}
int main(){
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	ll x, y, cnt, pos;
	cin >> n >> m;
	ll a[n][m];
	for(ll i = 0; i < n; i++){
		for(ll j = 0; j < m; j++){
			cin >> a[i][j];
		}
	}
	cin >> x >> y >> pos >> cnt;
	x--; y--; 
	bool vis[n][m][3][3];
	memset(vis, false, sizeof(vis));
	queue<edge> q;
	ll d_x;
	ll d_y;
	if(pos == 1){
		d_x = -1;
		d_y = -1;
	}
	if(pos == 2){
		d_x = -1;
		d_y = 0;
	}
	if(pos == 3){
		d_x = -1;
		d_y = 1;
	}
	if(pos == 4){
		d_x = 0;
		d_y = -1;
	}
	if(pos == 5){
		d_x = 0;
		d_y = 1;
	}
	if(pos == 6){
		d_x = 1;
		d_y = -1;
	}
	if(pos == 7){
		d_x = 1;
		d_y = 0;
	}
	if(pos == 8){
		d_x = 1;
		d_y = 1;
	}
	q.push({x, y, d_x, d_y, 0});
	ll ans = 0;
	while(!q.empty()){
		edge one = q.front();
		ll i = one.x;
		ll j = one.y;
		ll dx = one.dx;
		ll dy = one.dy;
		ll c = one.cnt;
		q.pop();
		//cout << i << " " << j << " " << dx << " " << dy << '\n';
		if(vis[i][j][dx+1][dy+1]) break;
		vis[i][j][dx+1][dy+1] = true;
		if(c%cnt == 0){
			ans += a[i][j];
		}
		a[i][j] = 0;
		if(corner(i, j) && (i+dx < 0 || i+dx>=n || j + dy < 0 || j + dy >= m)){
			dx *= -1;
			dy *= -1;
			q.push({i+dx, j+dy, dx, dy, c+1});
		}
		else if(wall(i, j) && (i+dx < 0 || i+dx>=n || j + dy < 0 || j + dy >= m)){
			if(i == 0 || i == n-1){
				dx *= -1;
			}
			if(j == 0 || j == m-1){
				dy *= -1;
			}
			q.push({i+dx, j+dy, dx, dy, c+1});
		}
		else{
			q.push({i+dx, j+dy, dx, dy, c+1});
		}
	}
	cout << ans << '\n';
	return 0;
}