// ConsoleApplication15.cpp:      .
//


#include <string>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <cmath>
#include <iostream>
using namespace std;
long long uselessVariable;
vector<long long> downEdge(3, 0);
vector<long long> upEdge(3, 0);
long long n;

vector<pair<vector<long long>, vector<long long>>> edgeOpis;

void blder(vector<long long> history, long long currentLevel, long long currentId, vector<long long> mask){
	if (currentLevel == 1){
		if (edgeOpis[currentId].first != downEdge) return;
		history.push_back(currentId);
		mask[currentId]  = 0;
		for(long long i = 0;i < n;i++){
			if (mask[i] == 1){
				blder(history, currentLevel + 1, i, mask);
			}
		}
	}
	else if (currentLevel == n){
		if (edgeOpis[currentId].second != upEdge) return;
		long long lastId = history[history.size() - 1];
		vector<long long> u = edgeOpis[lastId].second;
		vector<long long> d = edgeOpis[currentId].first;
		if (u == d){
			history.push_back(currentId);
			mask[currentId] = 0;
			for(long long i = 0;i < n;i++){
				cout << history[i] + 1 << " ";
			}
		}
		return;
	}

	long long lastId = history[history.size() - 1];
	vector<long long> u = edgeOpis[lastId].second;
	vector<long long> d = edgeOpis[currentId].first;
	if (u == d){
		history.push_back(currentId);
		mask[currentId] = 0;
		for(long long i = 0;i < n;i++){
			if (mask[i] == 1){
				blder(history, currentLevel + 1, i, mask);
			}
		}
	}

}

int main()
{
	cin >> n;
	edgeOpis.resize(n);
	for(long long i = 0;i < n;i++){
		
		vector<vector<long long>> mass(3, vector<long long> (3, 0));
		for(long long i = 0;i < 3;i++){
			for(long long j = 0;j < 3;j++){
				cin >> mass[i][j];
			}
		}
		vector<long long> eUp(3, 0);
		vector<long long> eDown(3, 0);
		long long u0 = 0, u1 = 0, u2 = 0;
		long long d0 = 2, d1 = 2, d2 = 2;
		for(long long i = 0;i < 2;i++){
			if(mass[i][0] == 0 && u0 == i){
				eUp[0]++;
				u0++;
			}
			if(mass[i][1] == 0 && u1 == i){
				eUp[1]++;
				u1++;
			}
			if(mass[i][2] == 0 && u2 == i){
				eUp[2]++;
				u2++;
			}
		}
		for(long long i = 2;i > 0;i--){
			if(mass[i][0] == 0 && d0 == i){
				eDown[0]++;
				d0--;
			}
			if(mass[i][1] == 0 && d1 == i){
				eDown[1]++;
				d1--;
			}
			if(mass[i][2] == 0 && d2 == i){
				eDown[2]++;
				d2--;
			}
		}
		long long m = max(eUp[0], max(eUp[1], eUp[2]));
		eUp[0] = m - eUp[0];
		eUp[1] = m - eUp[1];
		eUp[2] = m - eUp[2];

		edgeOpis[i].first = eDown;
		edgeOpis[i].second = eUp;
	}
	vector<long long> emptyV;
	vector<long long> defMask(n, 1);
	for(long long i = 0;i < n;i++){
		blder(emptyV, 1, i, defMask);
	}



	




	




	//cin >> uselessVariable;
	return 0;
}

