import itertools
import math

n = int(input())

pieces = []
top_piece_ind = -1
bot_piece_ind = -1

for i in range(n):
    piece = []
    for j in range(4):
        c = list(map(int, input().split()))
        if c == [1, 1, 1, 1] and j == 3:
            bot_piece_ind = i
        elif c == [1, 1, 1, 1] and j == 0:
            top_piece_ind = i
        piece.append(c)

    pieces.append(piece)

types = []
for i in range(n):
    types.append(i)

good_ways = []

for iteration in itertools.permutations(types):
    if iteration[0] == bot_piece_ind and iteration[-1] == top_piece_ind:
        good_ways.append(iteration)

# print(top_piece_ind, bot_piece_ind)

c = 1
for way in good_ways:
    # print(f"Type {c}:")
    # print(f"Tower code: {way}")
    # print()
    tower_prompt = []
    for i in way[::-1]:
        for piece in pieces[i]:
            tower_prompt.append(piece)

    tower_complexed = []

    i = 0
    while i < len(tower_prompt):

        tower_complexed.append(tower_prompt[i].copy())

        if 0 in tower_complexed[-1]:
            for j in range(4):
                tower_complexed[-2][j] += tower_complexed[-1][j]
            tower_complexed.pop(-1)
        i += 1

    ok = True

    for piece in tower_complexed:
        for i in range(1, 4):
            if piece[0] != piece[i]:
                ok = False

    # for i in tower_complexed:
    #     print(i)

    if ok:
        for i in way:
            print(i + 1, end=" ")
        # print(way)
        exit()