#include <iostream>
#include <vector>

#define int long long

using namespace std;

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, m;
    cin >> n >> m;

    vector<vector<int>> a(n, vector<int>(m));

    for (auto& i : a) for (auto& j : i) cin >> j;

    int i, j;
    cin >> i >> j;
    i--;
    j--;

    vector<vector<bool>> used(n, vector<bool>(m, false));

    int d, step;
    cin >> d >> step;

    int leftStep = step;

    int res = 0;

    while (true) {
        if (used[i][j]) break;
        used[i][j] = true;
        res += a[i][j];
        while (leftStep != 0) {
            while (true) {
                if (d == 1) {
                    if (i == 0 && j == 0) {
                        d = 7;
                    } else if (i == 0) {
                        d = 4;
                    } else if (j == 0) {
                        d = 5;
                    } else {
                        break;
                    }
                } else if (d == 2) {
                    if (i == 0) {
                        d = 6;
                    } else {
                        break;
                    }
                } else if (d == 3) {
                    if (i == 0 && j == m - 1) {
                        d = 4;
                    } else if (i == 0) {
                        d = 7;
                    } else if (j == m - 1) {
                        d = 2;
                    } else {
                        break;
                    }
                } else if (d == 4) {
                    if (j == 0) {
                        d = 8;
                    } else {
                        break;
                    }
                } else if (d == 5) {
                    if (j == m - 1) {
                        d = 1;
                    } else {
                        break;
                    }
                } else if (d == 6) {
                    if (i == n - 1 && j == 0) {
                        d = 5;
                    } else if (i == n - 1) {
                        d = 2;
                    } else if (j == 0) {
                        d = 7;
                    } else {
                        break;
                    }
                } else if (d == 7) {
                    if (i == n - 1) {
                        d = 3;
                    } else {
                        break;
                    }
                } else if (d == 8) {
                    if (i == n - 1 && j == m - 1) {
                        d = 2;
                    } else if (i == n - 1) {
                        d = 5;
                    } else if (j == m - 1) {
                        d = 4;
                    } else {
                        break;
                    }
                }
            }
            if (d == 1) {
                i--;
                j--;
            } else if (d == 2) {
                i--;
            } else if (d == 3) {
                i--;
                j++;
            } else if (d == 4) {
                j--;
            } else if (d == 5) {
                j++;
            } else if (d == 6) {
                i++;
                j--;
            } else if (d == 7) {
                i++;
            } else if (d == 8) {
                i++;
                j++;
            }
            leftStep--;
        }
        leftStep = step;
    }

    cout << res;
 
    return 0;
}
