#include <iostream>
#include <vector>

#define int long long

using namespace std;

struct building {
    int id;
    int lastIn;
    int lastOut;

    building() : id(0), lastIn(0), lastOut(0) {}
    building(int id, int lastIn, int lastOut) : id(id), lastIn(lastIn), lastOut(lastOut) {}
};

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int x, y;
    cin >> x >> y;

    vector<vector<int>> days(4, vector<int>(5));
    for (auto& i : days) for (auto& j : i) cin >> j;

    int c1 = 30, c2 = 30, c3 = 30, c4 = 30;

    vector<building> a;

    for (int i = 1; i <= 100; ++i) {
        if (i % 10 == 0) {
            c1 += x;
            c2 += x;
            c3 += x;
            c4 += x;
        }
        for (int j = 0; j < a.size(); ++j) {
            if (a[j].id == 1) {
                if (a[j].lastIn + 2 == i) {
                    c1 += 2;
                    c3 += 5;
                    a[j].lastIn += 2;
                }
                if (a[j].lastOut + 5 == i) {
                    c1 -= 3;
                    a[j].lastOut += 5;
                }
            } else if (a[j].id == 2) {
                if (a[j].lastIn + 5 == i) {
                    c4 += 7;
                    a[j].lastIn += 5;
                }
                if (a[j].lastOut + 10 == i) {
                    c3 -= 2;
                    a[j].lastOut += 10;
                }
            } else if (a[j].id == 3) {
                if (a[j].lastIn + 10 == i) {
                    c2 += 6;
                    a[j].lastIn += 10;
                }
                if (a[j].lastOut + 18 == i) {
                    c1 -= 2;
                    a[j].lastOut += 18;
                }
            } else {
                if (a[j].lastIn + 8 == i) {
                    c3 += 8;
                    a[j].lastIn += 8;
                }
                if (a[j].lastOut + 12 == i) {
                    c1 -= 1;
                    c2 -= 1;
                    a[j].lastOut += 12;
                } 
            }
        }

        c1 -= y;
        c2 -= y;
        c3 -= y;
        c4 -= y;

        for (int j = 0; j < 5; ++j) {
            if (days[0][j] == i) {
                if (c1 >= 8 && c2 >= 3 && c3 >= 10) {
                    c1 -= 8;
                    c2 -= 3;
                    c3 -= 10;
                    a.emplace_back(building(1, i + 4, i + 4));
                }
            }
            if (days[1][j] == i) {
                if (c1 >= 5 && c3 >= 8) {
                    c1 -= 5;
                    c3 -= 8;
                    a.emplace_back(building(2, i + 4, i + 4));
                }
            }
            if (days[2][j] == i) {
                if (c1 >= 10 && c2 >= 6 && c3 >= 10) {
                    c1 -= 10;
                    c2 -= 6;
                    c3 -= 10;
                    a.emplace_back(building(3, i + 9, i + 9));
                }
            }
            if (days[3][j] == i) {
                if (c1 >= 8 && c2 >= 4 && c3 >= 8) {
                    c1 -= 8;
                    c2 -= 4;
                    c3 -= 8;
                    a.emplace_back(building(4, i + 7, i + 7));
                }
            }
        }

        if (c1 <= 0 || c2 <= 0 || c3 <= 0 || c4 <= 0) {
            cout << i << '\n' << c1 << '\n' << c2 << '\n' << c3 << '\n' << c4;
            return 0;
        }
    }

    cout << 100 << '\n' << c1 << '\n' << c2 << '\n' << c3 << '\n' << c4;
    return 0;
}
