﻿
#include <iostream>
#include <vector>
using namespace std;
int main()
{
	int n, m, x, y, nap;
	cin >> n >> m;
	vector<vector<int>> v(n, vector<int>(m));
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			cin >> v[i][j];
		}
	}
	cin >> x >> y >> nap;
	x--; y--; nap--;
	vector<pair<int, int>> way = {
		{-1, -1},
		{-1, 0},
		{-1, 1},
		{0, 1},
		{1, 1},
		{1, 0},
		{1, -1},
		{0, -1}
	};
	vector<pair<int, int>> way_norm = {
	{-1, -1},
	{-1, 0},
	{-1, 1},
	{0, -1},
	{0, 1},
	{1, -1},
	{1, 0},
	{1, 1}
	};

	vector<vector<bool>> used(n, vector<bool>(m, true));
	int delta_x = way_norm[nap].first, delta_y = way_norm[nap].second;
	long long res = v[x][y];
	while (used[x][y]) {
		while (x + delta_x >= n || y + delta_y >= m || x + delta_x < 0 || y + delta_y < 0) {
			if (x + delta_x < 0 || x + delta_x >= n)
				delta_x *= -1;
			if (y + delta_y < 0 || y + delta_y >= m)
				delta_y *= -1;
			for (int i = 0; i < 8; i++) {
				if (delta_x == way[i].first && delta_y == way[i].second) {
					delta_x = way[(i + 1) % 8].first;
					delta_y = way[(i + 1) % 8].second;
					break;
				}
			}

		}
		used[x][y] = false;
		x += delta_x;
		y += delta_y;
		if (!used[x][y]) {
			cout << res;
			return 0;
		}
		res += v[x][y];
	}
	cout << res;
	return 0;
}
