#include <bits/stdc++.h>

#define rep(i, n) for(int i = 0; i < (n); ++i)
#define rep1(i, n) for(int i = 1; i <= (n); ++i)

using namespace std;
using i64 = long long;

mt19937 rd(chrono::steady_clock::now().time_since_epoch().count());

map<int, deque<int>> to_build;
vector<int> guys[4];

void solve(){
    int x, y;
    cin >> x >> y;
    rep(i, 4){
        rep(j, 5){
            int t;
            cin >> t;
            if(t != 0){
                to_build[t].push_back(i);
            }
        }
    }
    int res[] = {40, 40, 40, 40};
    bool building[] = {0, 0, 0, 0};
    auto get1 = [&](int t, int now) -> void {
        building[0] |= (now < t + 6);
        if(now - t - 6 + 1 > 0 && (now - t - 6 + 1) % 2 == 0){
            res[0] += 2, res[2] += 1;
        }
    };
    auto get2 = [&](int t, int now) -> void {
        building[1] |= (now < t + 4);
        if((now - t - 4 + 1) > 0 && (now - t - 4 + 1) % 6 == 0){
            res[3] += 8;
        }
    };
    auto get3 = [&](int t, int now) -> void {
        building[2] |= (now < t + 10);
        if((now - t - 10 + 1) > 0 && (now - t - 10 + 1) % 10 == 0){
            res[1] += 6;
        }
    };
    auto get4 = [&](int t, int now) -> void {
        building[3] |= (now < t + 8);
        if(now - t - 8 + 1 > 0 && (now - t - 8 + 1) % 7 == 0){
            res[2] += 7;
        }
    };
    auto lose1 = [&](int t, int now) -> void {
        if(now - t - 6 + 1 > 0 && (now - t - 6 + 1) % 5 == 0){
            res[0] -= 1;
        }
    };
    auto lose2 = [&](int t, int now) -> void {
        if((now - t - 4 + 1) > 0 && (now - t - 4 + 1) % 10 == 0){
            res[2] -= 2;
        }
    };
    auto lose3 = [&](int t, int now) -> void {
        if((now - t - 10 + 1) > 0 && (now - t - 10 + 1) % 20 == 0){
            res[0] -= 2;
        }
    };
    auto lose4 = [&](int t, int now) -> void {
        if(now - t - 8 + 1 > 0 && (now - t - 8 + 1) % 12 == 0){
            res[0] -= 1, res[1] -= 1;
        }
    };
    auto build1 = [&](int t) -> void {
        if(!building[0] && res[0] > 5 && res[1] > 5 && res[2] > 5){
            res[0] -= 5, res[1] -= 5, res[2] -= 5;
            guys[0].push_back(t);
        }
    };
    auto build2 = [&](int t) -> void {
        if(!building[1] && res[2] > 10 && res[0] > 5){
            res[2] -= 10, res[0] -= 5;
            guys[1].push_back(t);
        }
    };
    auto build3 = [&](int t) -> void {
        if(!building[2] && res[1] > 5 && res[0] > 10 && res[2] > 10){
            res[1] -= 5, res[0] -= 10, res[2] -= 10;
            guys[2].push_back(t);
        }
    };
    auto build4 = [&](int t) -> void {
        if(!building[3] && res[1] > 5 && res[0] > 10 && res[2] > 8){
            res[1] -= 5, res[0] -= 10, res[2] -= 8;
            guys[3].push_back(t);
        }
    };
    for(int day = 1; day <= 100; ++day){
        if(day % 10 == 0) rep(i, 4) res[i] += x;

        rep(i, 4) building[i] = 0;
        for(int i : guys[0]) get1(i, day);
        for(int i : guys[1]) get2(i, day);
        for(int i : guys[2]) get3(i, day);
        for(int i : guys[3]) get4(i, day);

        rep(i, 4) res[i] -= y;

        for(int i : guys[0]) lose1(i, day);
        for(int i : guys[1]) lose2(i, day);
        for(int i : guys[2]) lose3(i, day);
        for(int i : guys[3]) lose4(i, day);

        for(int i : to_build[day]){
            if(i == 0) build1(day);
            if(i == 1) build2(day);
            if(i == 2) build3(day);
            if(i == 3) build4(day);
        }

        rep(i, 4) if(res[i] <= 0){
            cout << day << '\n' << res[0] << '\n' << res[1] << '\n' << res[2] << '\n' << res[3];
            return;
        }
    }
    cout << 100 << '\n' << res[0] << '\n' << res[1] << '\n' << res[2] << '\n' << res[3];
}

signed main(){
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    //

#ifdef requiem
    freopen("input.in", "r", stdin);
    freopen("output.out", "w", stdout);
#endif

    int tt = 1;
    // cin >> tt;
    rep(i, tt){
        solve();
    }

    // cerr << fixed << 1.0 * clock() / CLOCKS_PER_SEC;
    return 0;
}
