
#include <bits/stdc++.h>
#define int long long
#define fr for

using namespace std;
vector<int> res(4, 40);
struct zavod;
vector<vector<pair<int, int>>> ev(200);

struct zavod{
    int id = 0;
    vector<int> will = {0, 0, 0, 0};
    vector<int> need = {0, 0, 0, 0};
    int t_will = 0;
    int t_need = 0;
    vector<int> price = {0, 0, 0, 0};
    int t_to_build = 0;
    zavod(int id2=0, vector<int> will2={}, vector<int> need2={}, int t_will2=0, int t_need2=0, vector<int> price2={}, int t_to_build2=0){
        id = id2;
        will = will2;
        need = need2;
        price = price2;
        t_will = t_will2;
        t_need = t_need2;
        t_to_build = t_to_build2;
    }
    void build(int time){
        ev[time+t_to_build+t_will-1].push_back({0, id}); // 0 - получить
        ev[time+t_to_build+t_need-1].push_back({1, id}); // 1 - потребить
        for (int i = 0; i<4; i++){
            res[i] -= price[i];
        }
    }
    void consume(int time){
        ev[time+t_need].push_back({1, id});
        for (int i = 0; i<4; i++){
            res[i] -= need[i];
        }
    }
    void produce(int time){
        ev[time+t_will].push_back({0, id});
        for (int i = 0; i<4; i++){
            res[i] += will[i];
        }
    }
};

void solve(){
    vector<zavod> zvd(5);
    zvd[1] = zavod(1, {2, 0, 1, 0}, {1, 0, 0, 0}, 2, 5, {5, 5, 5, 0}, 6);
    zvd[2] = zavod(2, {0, 0, 0, 8}, {0, 0, 2, 0}, 6, 10, {5, 0, 10, 0}, 4);
    zvd[3] = zavod(3, {0, 6, 0, 0}, {2, 0, 0, 0}, 10, 20, {10, 5, 10, 0}, 10);
    zvd[4] = zavod(4, {0, 0, 7, 0}, {1, 1, 0, 0}, 7, 12, {10, 5, 8, 0}, 8);
    int x, y;
    cin >> x >> y;
    for (int i = 1; i<=4; i++){
        for (int j = 0; j<5; j++){
            int x; cin >> x;
            ev[x].push_back({2, i});
        }
    }

    int t = 1;
    for (t = 1; t<=100; t++){
        for (auto v : ev[t]){
            if (v.first == 0){
                zvd[v.second].produce(t);
            }
            if (v.first == 1){
                zvd[v.second].consume(t);
            }
            if (v.first == 2){
                zvd[v.second].build(t);
            }
        }
        for (int i = 0; i<4; i++){
            res[i] -= y;
        }
        if (t%10 == 0){
            for (int i = 0; i<4; i++){
                res[i] += x;
            }
        }
        int bd = 0;
        for (int i = 0; i<4; i++){
            if (res[i] <= 0){
                bd = 1;
            }
        }
        if (bd) break;
    }

    cout << min(t, 100ll) << endl;
    for (auto v : res){
        cout << v << endl;
    }
    cout << endl;

}

signed main() {
    //freopen("input.txt", "r", stdin);
    solve();
    return 0;
}
