#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;

#define pii pair<int, int>
#define pll pair<ll, ll>

#define pb push_back
#define ins insert 
#define ers erase 
#define all(a) a.begin(), a.end()
#define accuracy(a) fixed << setprecision(a)
#define endl '\n'

const int INF = 1e9;
const ll LINF = 1e18;

void solve();

signed main()
{
    #ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    #else 
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    #endif

    solve();


    return 0;
}

void solve()
{
    int n;
    cin >> n;
    vector<int> a(n);
    vector<int> b(n);

    for(int i = 0; i < n; ++i) cin >> a[i];
    for(int i = 0; i < n; ++i) cin >> b[i];

    vector<int> v;
    for(int i = 0; i < n; ++i) {
        if (a[i] - b[i] > 0) v.pb(a[i] - b[i]);
    }

    int m = v.size();
    if (m == 0) {
        cout << 0;
        return;
    }

    if (m == 1) {
        cout << 1;
        return;
    }
    
    vector<int> dp(m + 1, INF);
    dp[0] = 0;
    dp[1] = v[0];

    for(int i = 1; i < m; ++i) {
        int j = 0;
        while(j <= m && dp[j] < v[i]) ++j;
        dp[j] = min(dp[j], v[i]);
    }

    int j = 0;
    while (j <= m && dp[j] < INF) {
        ++j;
    }

    cout << j - 1;
}