#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;

#define pii pair<int, int>
#define pll pair<ll, ll>

#define pb push_back
#define ins insert 
#define ers erase 
#define all(a) a.begin(), a.end()
#define accuracy(a) fixed << setprecision(a)
#define endl '\n'

const int INF = 1e9;
const ll LINF = 1e18;

void solve();

signed main()
{
    #ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    #else 
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    #endif

    solve();


    return 0;
}

void solve()
{
    int n, m;
    cin >> n >> m;
    vector<vector<ll> > v(n + 2, vector<ll> (m + 2 , -INF)) ;

    for(int i = 1; i <= n; ++i) {
        for(int j = 1; j <= m; ++j) {
            cin >> v[i][j];
       }
    }

    int a, b;
    cin >> a >> b;
    int vec, s;
    cin >> vec >> s;

    ll sum = 0;

    int i = a, j = b;
    int speedx, speedy;
    if (vec == 2 || vec == 7) {
        speedx = vec == 2 ? -1 : 1;
        speedy = 0;
        for(int steps = 0; steps < n * n; ++steps) {
            if (steps % s == 0) {
               if (v[i][j] != -INF) {
                sum += v[i][j];
                v[i][j] = 0;
               }
            }
            
            if (i + speedx > n || i + speedx < 1) {
                speedx = -speedx;
            }

             i += speedx;
        }
    } else if (vec == 4 || vec == 5) {
        speedy = vec == 4 ? -1 : 1;
        for(int steps = 0; steps < m * m; ++steps) {
             if (steps % s == 0) {
               if (v[i][j] != -INF) {
                sum += v[i][j];
                v[i][j] = 0;
               }
            }
            if (j + speedy > m || j + speedy < 1) {
                speedy = -speedy;
            }

             j += speedy;
        }
    } else {
        speedy = vec == 1 || vec == 6 ? -1 : 1;
        speedx = vec == 1 || vec == 3 ? -1 : 1;


        for(int steps = 0; steps < 7e7; ++steps) {
             if (steps % s == 0) {
               if (v[i][j] != -INF) {
                sum += v[i][j];
                v[i][j] = 0;
               }
            }
            if (j + speedy > m || j + speedy < 1) {
                speedy = -speedy;
            }

            if (i + speedx > n || i + speedx < 1) {
                speedx = -speedx;
            }

            i += speedx;
            j += speedy;
        }
    }


    cout << sum;
    
}