#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;

#define pii pair<int, int>
#define pll pair<ll, ll>

#define pb push_back
#define ins insert 
#define ers erase 
#define all(a) a.begin(), a.end()
#define accuracy(a) fixed << setprecision(a)
#define endl '\n'

const int INF = 1e9;
const ll LINF = 1e18;

void solve();

signed main()
{
    #ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    #else 
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    #endif

    solve();


    return 0;
}
int x, y;
int poli = 40;
int zap = 40;
int mic = 40;
int food = 40;
int curday = 1;
int freeid = 1;
struct build_info {
    int id;
    int start;
    int time;
};

map<int, int> builttime;
map<int, int> type;
vector<build_info> building;
vector<int> built;

void get_1(int id)
{
    if ((curday - builttime[id]) % 2 == 0) {
        zap += 2;
        poli += 1;
    }
}

void spend_1(int id) 
{
    if ((curday - builttime[id]) % 5 == 0) {
        --zap;
    }
}

void get_2(int id)
{
    if ((curday - builttime[id]) % 6 == 0) {
        food += 8;
    }
}

void spend_2(int id)
{
    if ((curday - builttime[id]) % 10 == 0) {
        poli -= 2;
    }
}

void get_3(int id) 
{
    if ((curday - builttime[id]) % 10 == 0) {
        mic += 6;
    }
}

void spend_3(int id)
{
    if ((curday - builttime[id]) % 20 == 0) {
        zap -= 2;
    }
}

void get_4(int id)
{
    if ((curday - builttime[id]) % 7 == 0) {
        poli += 7;
    }
}

void spend_4(int id) 
{
    if ((curday - builttime[id]) % 12 == 0) {
        --zap;
        --mic;
    }
}

void check_state()
{
    if (poli <= 0 || zap <= 0 || mic <= 0 || food <= 0) {
        cout << curday << endl << zap << endl << mic << endl << poli << endl << food << endl;
        exit(0);
    } 
}

void solve()
{
    cin >> x >> y;
    vector<vector<int> > plan(5, vector<int> (6));

    for(int i = 1; i <= 4; ++i) {
        for(int j = 1; j <= 5; ++j) {
            cin >> plan[i][j];
        }
    }

    for(; curday <= 100; ++curday) {
        if (curday % 10 == 0) {
            zap += x;
            poli += x;
            mic += x;
            food += x;
        } 

        for(int id : built) {
            if (type[id] == 1) get_1(id);
            if (type[id] == 2) get_2(id);
            if (type[id] == 3) get_3(id);
            if (type[id] == 4) get_4(id);
        }

        zap -= y;
        poli -= y;
        mic -= y;
        food -= y;

        for(int i = 1; i <= 4; ++i) {
            for(int j = 1; j <= 5; ++j) {
                if (plan[i][j] == curday) {
                    build_info info;
                    info.id = freeid;
                    type[freeid] = i;
                    info.start = curday;
                    if (i == 1) {
                        zap -= 5;
                        mic -= 5;
                        poli -= 5;
                        info.time = 6;
                    }
                    if (i == 2) {
                        zap -= 5;
                        poli -= 10;
                        info.time = 4;
                    }
                    if (i == 3) {
                        mic -= 5;
                        zap -= 10;
                        poli -= 10;
                        info.time = 10;
                    }
                    if (i == 4) {
                        mic -= 5;
                        zap -= 10;
                        poli -= 8;
                        info.time = 8;
                    }

                    freeid++;

                    building.pb(info);
                }
            }
        }

        for(int id : built) {
            if (type[id] == 1) spend_1(id);
            if (type[id] == 2) spend_2(id);
            if (type[id] == 3) spend_3(id);
            if (type[id] == 4) spend_4(id);
        }

        for(auto info : building) {
            if (info.start + info.time - 1 == curday) {
                built.pb(info.id);
                builttime[info.id] = curday;
            }
        }

        check_state();
    }

    cout << curday - 1 << endl << zap << endl << mic << endl << poli << endl << food << endl;
}
