#include <iostream>
#include <string>
#include <stdint.h>

// 123
// 456
// 789
//  0

uint32_t distHor[10][10] = {
    { 0, 1, 0, 1, 1, 0, 1, 1, 0, 1 },
    { 1, 0, 1, 2, 0, 1, 2, 0, 1, 2 },
    { 0, 1, 0, 1, 1, 0, 1, 1, 0, 1 },
    { 1, 2, 1, 0, 2, 1, 0, 2, 1, 0 },
    { 1, 0, 1, 2, 0, 1, 2, 0, 1, 2 },
    { 0, 1, 0, 1, 1, 0, 1, 1, 0, 1 },
    { 1, 2, 1, 0, 2, 1, 0, 2, 1, 0 },
    { 1, 0, 1, 2, 0, 1, 2, 0, 1, 2 },
    { 0, 1, 0, 1, 1, 0, 1, 1, 0, 1 },
    { 1, 2, 1, 0, 2, 1, 0, 2, 1, 0 }
};

uint32_t distVer[10][10] = {
    { 0, 3, 3, 3, 2, 2, 2, 1, 1, 1 },
    { 3, 0, 0, 0, 1, 1, 1, 2, 2, 2 },
    { 3, 0, 0, 0, 1, 1, 1, 2, 2, 2 },
    { 3, 0, 0, 0, 1, 1, 1, 2, 2, 2 },
    { 2, 1, 1, 1, 0, 0, 0, 1, 1, 1 },
    { 2, 1, 1, 1, 0, 0, 0, 1, 1, 1 },
    { 2, 1, 1, 1, 0, 0, 0, 1, 1, 1 },
    { 1, 2, 2, 2, 1, 1, 1, 0, 0, 0 },
    { 1, 2, 2, 2, 1, 1, 1, 0, 0, 0 },
    { 1, 2, 2, 2, 1, 1, 1, 0, 0, 0 }
};

int main() {
    std::string str;
    std::cin >> str;

    uint32_t n;
    std::cin >> n;

    uint32_t dist = 0;

    switch(n) {
        case 0: {
            for(uint32_t i = 0; i < str.size() - 1; i++) {
                const uint8_t o = str[i] - '0';
                const uint8_t d = str[i + 1] - '0';
                dist += distHor[o][d];
            }
            break;
        }

        case 1: {
            for(uint32_t i = 0; i < str.size() - 1; i++) {
                const uint8_t o = str[i] - '0';
                const uint8_t d = str[i + 1] - '0';
                dist += distVer[o][d];
            }
            break;
        }
    }

    std::cout << dist << "\n";

    return 0;
}
